#line 3069 "ext.nw"
require "pwd.pl";
&initpwd;


#line 1081 "ext.nw"
$mode = $ARGV[0] && shift;
$filearg = $ARGV[0] && shift;

if ($mode eq "Mkman" || $mode eq "lextract") 
{ $numbered = "yes"; }
else 
{ $numbered  = "no";}      
  # Usually manual pages are not numbered
$ack = "yes";            
  # ext asks for acknowledgments when it is confused
$constref = "no";   
  # const-& pairs are usually suppressed
$partypes = "no";   
  # operators suppress argument types that are identical to Mname
$usesubscripts = "no";    
  # usually we do not write indexed variables as subscripts
$size = 12;             
  # default size is 12pt
$xdvi = "yes";
$warnings = "yes";
$informational = "yes";
  # default is to give warnings, to give progress report 
$debugging = "no";
  # no debugging information
$indexing = "no";
$indexentry = "";
  # create no indexing output, indexentry is global index entry buffer
$includefile = "no";

$filter = "all";        
  # usually we show everything

$pid = "";            
  # we do not know the process id yet
$latexruns=1;
@substlist = ();     
  # a list L1,R1,L2,R2,....  of all substitutions
$delman = "yes";     
  # Ldoc usually removes manual comments
$outfile = "";       
  # the default is that we determine the outfile
$dvioutfile = "";     
  # only relevant for Mkdvi
$section = "section"; 
  # each manual page is a LaTeX section 
$nextwarning = "yes"; 
  # default is to show the next warning
$justset = "no";      
  # $nextwarning was not just set to no.
$noweaveoptions = "";  
  # we start with no options.
if ($mode eq "Lman" || $mode eq "Mkman" || $mode eq "lextract" ||
    $mode =~ /HTML/ || $mode eq "Fman" )
{ $print_title = "yes"; }
else
{ $print_title = "no"; }

$HTMLopentabular = "no";
#line 3754 "ext.nw"
%texreplacementtable = (
 'Lvert', '\|',
 'cdot' , '*',
 'leq', '<=',
 'le', '<=',
 'geq', '>=',
 'ge', '>=',
 'neq', '!=',
 'ne', '!=',
 'in', '\mathrm{\ in\ }',
 'not=', '!=',
 'notin', '\mathrm{\ not in\ }',
 'not', '\mathrm{\ not\ }',
 'equiv', '==',
 'pm', '+-',
 'cap', ' <intersection> ',
 'cup', ' <union> ',
 'pi', ' {pi} ',
 'ell', ' {l} ',
 'epsilon', '\mathrm{\ epsilon\ }',
 'alpha', '\mathrm{\ alpha\ }',
 'emptyset', '\mathrm{\ emptyset\ }',
 'real', '\mathrm{\ R\ }',
 'rightarrow', '->',
 'longrightarrow', '->',
 'Leftrightarrow', '<=>',
 'subset', '\mathrm{\ proper subset of\ }',
 'subseteq', '\mathrm{\ subset of\ }',
 'cal', '',
);


#line 1151 "ext.nw"
if ($mode eq "Fman") {
  if ($ARGV[0]) {
    $filter = $ARGV[0];    
    foreach  $candidate ("all","signatures","definition","types", "events",
                         "creation","operations","implementation","example") {
      if ($filter eq $candidate) { goto filterfound; }
    }
    &print_info("Searching for operation $filter of type $filearg");
    filterfound:
  } 
}
else {
  foreach $path ("HOME","PWD") {
    if ($path eq "HOME") {
      $CFG = $ENV{$path} . "\/" . $mode . "\.cfg";
    }
    else {
      $CFG = $mode . "\.cfg";
    }
    if (-e $CFG) {
      open (CFG); 
      &print_info("Reading $CFG");
      while (<CFG>) {
        if (/^(\w+)=(.*)$/) 
	{ eval "\$$1 = \$2"; } 
      }
      close (CFG);
    }
  }
  eval "\$$1 = \$2" while $ARGV[0] =~ /(\w+)=(.*)/ && shift; 
}

if ($informational eq "no") { $dontshowinfo = '> /dev/null'; }
if ($pid eq "") { $pid = $$; }
if ( $warnings eq "log" ) { open(LOGFILE,">>$mode.log"); }


$showsem = 1;          # usually we show the semantics of functions
if ($filter eq "signatures") {
  $filter = "operations";
  $showsem = 0;
}

 

#line 1228 "ext.nw"
&print_info("$mode version 2.3");
if (!($filearg)) { 
  &print_usage($mode); 
}
if ( $filearg eq "mancommands" ) {
  &print_mancommands($mode);
}
if ( $filearg eq "ltools" || 
     $filearg eq "Lman" ||
     $filearg eq "Ldoc") {
  &print_ltools($mode);
}


$TAMEROOT = $ENV{"TAMEROOT"};
$INCL = $ENV{"TAMEROOT"} . "/include";

if ($mode =~ /HTML/) {
  $INPUT = "namereplacementtable";
  open (INPUT)  || die "Error: Can't find input file $INPUT: $!\n";
 
  while (<INPUT>) {
    chop;
    if (/^\s*$/) { next; } # skip empty lines
    s/\t/ /g;  # subsitute a tab by a blank; some people write xxx\tyyy
    if (/^\s*(\S+)\s+(\S+)\s*$/) {
      $LEDAname = $1;
      $URL = $2;
    }
    else {
      /^\s*(\S+)\s*$/;
      $LEDAname = $1;
      $URL = $1;
    }
    $namereplacementtable{"$LEDAname"} = $URL;
  }
  close (INPUT);

}

if ($filearg =~ /(.*)\.[whln]/)
{ $basename = $1; }
else
{ $basename = $filearg; }

if (-e ($basename . "\.w")) 
{ $INPUT = $basename . "\.w" ; $kind = "Cweb"; $ext = "w"; goto DONE; }
if (-e ($basename . "\.web")) 
{ $INPUT = $basename . "\.web" ; $kind = "Cweb"; $ext = "web"; goto DONE; }
if (-e ($basename . "\.lw")) 
{ $INPUT = $basename . "\.lw" ; $kind = "Lweb";$ext = "lw"; goto DONE; }
if (-e ($basename . "\.nw")) 
{ $INPUT = $basename . "\.nw" ; $kind = "noweb"; $ext = "nw"; goto DONE; }
if (-e ($basename . "\.h")) 
{ $INPUT = $basename . "\.h" ; $kind = "h"; goto DONE; }
$longname = $INCL . "/" . $basename;
if (-e ($longname . "\.h"))
{ $INPUT = $longname . "\.h" ; $kind = "LEDAtype"; }

if ($mode eq "Lman" && $xdvi eq "yes" && 
    (-e "$TAMEROOT/Manual/DVI/$basename.dvi")) {
  &print_info("  Taking $TAMEROOT/Manual/DVI/$basename.dvi as a shortcut");
  system("xdvi $TAMEROOT/Manual/DVI/$basename.dvi $dontshowinfo");
  exit;
}    

DONE:
open (INPUT)  || die "Error: Cannot find input file $basename.[w|lw|nw|h]: $!\n\n";

if ($mode ne "Fman") {
  if ($outfile eq ""  || $mode eq "Ldoc") {
    $outfile = "/tmp/" . $pid . "-ext.tex";
  }
  open(OUTPUT,">".$outfile);
  &print_info("Reading input file $INPUT to extract manual ...");
}



#line 1324 "ext.nw"
local($preambletext)="";
if ($mode eq "HTMLman" )
{ 
  $preambletext .= "\\documentclass[a4paper]{article}\n";
  $preambletext .= "\\usepackage{html}\n";
  $preambletext .= "\\input ".$ENV{"TAMEROOT"}."/Manual/tex/MANUAL.mac\n\n";
  $preambletext .= "\\begin{document}\n";
  print_unit($preambletext);
} 
elsif ($mode eq "Lman") 
{
  $preambletext .= "\\documentclass\[".$size."pt,a4paper\]\{article\}\n\n"; 
  $preambletext .= "\\input ".$ENV{"TAMEROOT"}."/Manual/tex/MANUAL.pagesize\n";
  $preambletext .= "\\input ".$ENV{"TAMEROOT"}."/Manual/tex/MANUAL.mac\n\n";
  $preambletext .= "\\begin\{document\}\n";
  $preambletext .= "\\begin\{manual\}\n";                        
  print_unit($preambletext);
} 
elsif ($mode eq "Ldoc" || $mode eq "Mkman" || $mode eq "lextract") 
{ print_unit("\\begin{manual}\n"); }



#line 1367 "ext.nw"
$Mvar    = "";
$Mtype   = ""; 
$Mname   = "";
$MIname =  "";
main_loop:
{ # $_ is either undefined or the last line of an Mcomment
  
#line 1395 "ext.nw"
# I advance $_ to a non-empty line (WEB-directives are output but count as 
# empty lines otherwise) or beyond the end of the file

$_ = <INPUT>;

build_code_unit:
    while ($_ && (($_ =~ /^\s*$/) || ($_ =~ /^\@[sf]/)))
    { $_ = <INPUT>; }
    if (! $_) { last main_loop; }   # input exhausted
    $code_unit = "";
    # $_ exists, is non_empty, and contains no @, and $code_unit is empty
    # The code_unit is either terminated by an Mcomment or an empty line
    # (empty line: only white space characters) or the end of the file
    while ($_ && !(/\/\*\{\\M/ || /^\s*$/)) {
      if ($_ =~ /\/\* *\{M/) {
        &print_warning("I encountered /*{M. Did you really mean it?");
      }     
      $code_unit .= $_;   # append current line to code unit
      $_ = <INPUT>;
    }

# The current line either does not exist or is either empty or the 
# begin of an Mcomment.
# Skip empty lines.

while ( $_ && /^ *$/ ){ $_ = <INPUT>; }

# the current line is non-empty (if it exists).

if (! $_) { last main_loop; }   # input exhausted

# the current line is non-empty.

if (! (/\/\*\{\\M/)) { 
  goto build_code_unit;  # start new code unit.
}  

@invisible_words = ('__exportC' , 
                    '__exportF' , 
	            '__exportD', 
	            '__typename');
foreach $invis_word (@invisible_words) {
  $code_unit =~ s/$invis_word//g;
}
$original_code_unit = $code_unit;


#line 1374 "ext.nw"
  # $_ is an Mline and variables $original_code_unit and $code_unit 
  # contain the current code unit. 
  
#line 1452 "ext.nw"
s/^(.*)\/\*\{\\//; # remove begin comment and everything before it

local($stuff)=$1;
$original_comment = $&.$_;
if ($stuff =~ /\S/) { # issue warning if something non-white before comment
  &print_warning("appending non-white stuff in front of begin comment"); 
  $code_unit .= $stuff;
}

$Mcomment = "";

while ($_ && (! ( /\}\*\// ) ) ) {

  if (/\} *\*\//) 
  { &print_warning("encountered } */ in manual comment. Did you mean }*/ ?"); }
  $Mcomment .= $_;
  $_ = <INPUT>;
}
if (! $_) { die "Error: missing end comment\n"; }

s/\}\*\/(.*)$/ /;  # replace end comment and everything after it by a blank
if ($1 =~ /\S/) { &print_warning("ignored non-white after Mcomment"); }

$Mcomment .= $_;   
$original_comment = $Mcomment;

# Mcomment contains the entire manual comment. We extract the command (the
# maximal alphanumeric prefix).

$Mcomment =~ /^(\w*)\W.*/;
$command = $1;
$Mcomment =~ s/$command *//;  # remove command and succeeding blanks
$command =~ s/^M//;           # remove the M

if (! ($command eq "\options")) {
  &apply_Msubst(*Mcomment); 
}
# we replace all substitution strings in the comment as an exception
# you can escape any string by a preceding backslash.



#line 1377 "ext.nw"
  # $Mcomment contains the manual command (without the brackets /*{\M and }*/
  # $Mcommand contains the command (without the leading M)
  
#line 1510 "ext.nw"
if ($nextwarning eq "no" && $justset eq "no") { $nextwarning = "yes";} 
$justset = "no";
switch: {
  if ($command eq 'options') {
    
#line 1558 "ext.nw"
$Mcomment =~ s/\s//g;
$Mcomment =~ /^(\w+)=(.*)$/ ;


if ($1 eq $outfile) {
  if ($print_title eq "no") { 
  # gives information if we are in Lman/Mkman mode 
  # where we don't want to change the outfile but 
  # just parse the manual comments in one file in
  # the given sequence
    close(OUTPUT);
    $outfile = $2;
    if ( $existing_outfiles{$output} == 1 )
    { open OUTPUT, ">>$outfile"; }
    else
    { $existing_outfiles{$output} = 1;
      open OUTPUT, ">$outfile";  
    }
  }
}
else
{  eval "\$$1 = \$2"; }

if ($nextwarning eq "no") {$justset = "yes";}


#line 1514 "ext.nw"
                
    last switch;
  }
  if ($command eq 'subst') {
    
#line 1595 "ext.nw"
while ($Mcomment =~ s/^([^\n\r]*)[\r\n]//) 
{ $substline = $1;
  if ($substline =~ /^(.*)#(.*)$/ || $substline =~ /^ *(\S+) +(\S+) *$/)
  { $leftside = $1; $rightside = $2;
    &remove_enclosing_blanks($leftside);
    &remove_enclosing_blanks($rightside);
    push(@substlist,$leftside); push(@substlist,$rightside);
  }
  else
  { if ($substline =~ /\S/) 
    { &print_warning("Msubst does not understand $substline"); }
  }
}
 
#line 1518 "ext.nw"
              
    last switch;
  }
  if ($command eq 'anpage') {
    
#line 1617 "ext.nw"
if (! ($Mcomment =~ /\{([^\{\}]*)\}\s*\{([^\{\}]*)\}\s*\{([^\{\}]*)\}\s*\{([^\{\}]*)\}/ || 
       $Mcomment =~ /\{([^\{\}]*)\}\s*\{([^\{\}]*)\}\s*\{([^\{\}]*)\}/ ) )                   
{ &print_warning("Manpage expects either three or four arguments"); }
$Mtype = $1;
$par_list = $2;
$title = $3;
if ($4) { $Mvar = $4; }
if ($par_list =~ /^ *$/) 
{ $MIname = $Mname = $Mtype; }
else {
  # remove excessive blanks in parlist but be case sensitive
  $par_list =~ s/ //g;
  local($opar_list) = $par_list;
  @params = split(',',$par_list);
  local($longtemplatepar)= (length($par_list) > 20);
  foreach $para (@params) 
  { if ( length($para) > 5 ) { $longtemplatepar=1; } }
  if ( $longtemplatepar ) 
  { $par_list = " ".join(", ",@params)." "; } 
  # we do something for long template params 
  # if we produce ,blank the command covert_M enables
  # line breaks in the template list, thus we do this
  # as soon as one param is longer than 7 characters or
  # if the parameter list is longer than 20 characters
  $Mname = $Mtype."<".$par_list.">";
  if ( length($opar_list) < 11 ) { $MIname = $Mname; }
  else { $MIname = $Mtype."<".substr($opar_list,0,7)."...>"; }
}

&create_indexentry($mode, $MIname, "class");

if ($print_title eq "yes") {
  # we print \section*{title (type')}\label{type}\n where type' is obtained
  # from type by quoting underscores.
  # if numbered is true we supress the star
  if ($mode ne "Fman") {
    my $Mtype1 = $Mtype;
    $Mtype1 =~ s/_/\\_/g;
    if ($numbered eq "yes" ) {$star = "";} else {$star = "*";}
    if ($mode =~ /HTML/) { &closetabular(); $star = ""; }
    &print_unit("\\$section$star \{ $title \( $Mtype1 )}\n".
		"\\label\{ $title \}\n\\label\{$Mtype\}");
  } else {
    &print_unit("$title ( $Mtype )");
  }
}
$includeline="";
if (($kind eq "LEDAtype" || $kind eq "h") && $includefile eq "yes") {
  $includeline = $INPUT;
  if ( $includeline =~ /LEDA/ ) 
  { $includeline =~ s/.*(LEDA.*)/$1/; } # chop off before LEDA
  $includeline = "\\\#include \< $includeline \>"; 
}


 
#line 1522 "ext.nw"
                        
    last switch;
  }
  if ($command eq 'definition' || 
      $command eq 'types' ||
      $command eq 'creation' ||
      $command eq 'operations' ||
      $command eq 'events' ||
      $command eq 'implementation' || 
      $command eq 'example') {
    
#line 1694 "ext.nw"
if ($command eq "creation" || $command eq "types" || $command eq "events") {
  # Mcomment may contain a varname and/or a length.
  @params = split(' ',$Mcomment);  # split at blanks
  foreach $i (0 .. $#params) {
    if ($params[$i] =~ /^[a-zA-Z]/) { 
      $Mvar = $params[$i]; 
    } # variable names start with a letter
    else {
      $a = $params[$i];
      if ($a =~ /^ *$/) 
      { &print_warning("something wrong in $command"); }
      if ($a =~ /^[0-9\.]*$/) 
      {$a = $a . 'cm';}
      local($settings) = "\\setlength\{\\declwidth}\{".$a."\}\n".
	                 "\\computewidths\n";
      &print_unit($settings) unless ($mode =~ /HTML/ || $mode eq "Fman");
    }
  }
  $Mcomment = "";
}


if ($command eq "operations") {
  # Mcomment is either empty or a b where a and b are lengths
  # If the lengths are without dimension then we add cm

  local($settings)= "";
  @params = split(' ',$Mcomment);  # split at blanks
  foreach $i (0 .. $#params) {
    $a = $params[$i];
    if ($a =~ /^[0-9\.]*$/) {$a = $a . 'cm';}
    if ($i == 0) { $settings .= "\\setlength\{\\typewidth\}\{" . $a . "\}\n" ;}
    else         { $settings .= "\\setlength\{\\callwidth\}\{" . $a . "\}\n" ;} 
  }
  $settings .= "\\computewidths\n";
  &print_unit($settings) unless ($mode =~ /HTML/ || $mode eq "Fman");
  $Mcomment = "";
}

$currentsection = $command;

# print mansections:

my($header,$semantics);
if ($filter eq "all" || $filter eq $currentsection) {
  &subst_vars(*Mcomment);
  if ($mode eq "Fman") {
    $header =  ucfirst($command)."\n____________________________";
    $semantics = &convert_to_ASCII($Mcomment,1,80);
    if ( $includeline ne "" ) 
    { $semantics .= "\n$includeline"; $includeline=""; }
  } elsif ($mode =~ /HTML/) {
    &closetabular();
    $header = "\\textbf\{\\large " . ucfirst($command) . "\}";
    $semantics = &convert_to_HTML($Mcomment);
    if ( $includeline ne "") 
    { $semantics .= "\n".&convert_R($includeline); $includeline=""; }
  } else { # Lman, Ldoc here !
    $header = "\\mansection\{ " . ucfirst($command) . " \}";
    if ($Mcomment) { $semantics = &convert_to_LaTeX($Mcomment); }
    if ($includeline) 
    { $semantics .= "\n". &convert_M($includeline); $includeline=""; }
  }
  &print_unit($header);
  &print_unit($semantics);
}
      
#line 1532 "ext.nw"
                        
    last switch;
  }
  if ($command eq 'text'  || $command eq "preamble") {
    
#line 1770 "ext.nw"
      
if ($filter eq "all" || $filter eq $currentsection ) { 
  &subst_vars(*Mcomment);
  if ($mode eq "Fman") {
      if ($showsem) { print_unit(&convert_to_ASCII($Mcomment,1,80)); }
  } elsif ($mode =~ /HTML/ ) {
    &closetabular();
    &print_unit(&convert_to_HTML($Mcomment));
  } elsif ($command eq "text" || $mode ne "Ldoc") { 
    &print_unit(&convert_to_LaTeX($Mcomment)); 
  }
}


#line 1536 "ext.nw"
                         
    last switch;
  }
  
#line 2004 "ext.nw"
$prefix = "";
$funcname = "";
$postfix = "";
$signature = ""; 
$enumconsts = "";
$type = "";
$fname = "";
$static = 0;
$constructor = 0;
$operator = 0;
$conversion = 0;
$destructor = 0;
$enum = 0;
$typedef = 0;
$localclass = 0;

if (!$code_unit) {
  &print_warning("current code unit is empty"); 
  last switch;
}
#line 2082 "ext.nw"
$code_unit =~ s/\@\+/ /g; # remove @+
$code_unit =~ s/\@\// /g; # remove @/
$code_unit =~ s/\@\|/ /g; # remove @|
$code_unit =~ s/\@\#/ /g; # remove @#
$code_unit =~ s/\@\;/ /g; # remove @;
$code_unit =~ s/\@\,/ /g; # remove @,

&print_debug("\nDEBUG code unit at start=$code_unit");

if ($code_unit =~ /\/\*/) {      # commented code units
  &print_warning("code unit contains a comment. ".
                 "I remove the lines containing /* and */");
  $code_unit =~ s/ *\/\*.*//;  # remove first line
  $code_unit =~ s/ *\*\/ *//;  # remove last line
  $original_code_unit = $code_unit;
}

$code_unit  =~ s/\/\/.*\n//g;  # remove C++ comment to end of line
$code_unit =~ s/\t/ /g;        # replace tab by blank
$code_unit =~ s/ *\#.*\n/ /g;  # remove all lines with compiler directives 
$code_unit =~ s/\n/ /g;        # replace newline characters by blanks

if ($code_unit =~ s/\{(.*)\}/\;/ ) 
{ $enumconsts = $1; }
$code_unit =~ s/\{.*/\;/g; # just an opening bracket purges rest
# note that we did the previous to enable a opening bracket behind
# the prototype not balanced by a closing one following way behind
# the man comment
while ($code_unit =~ s/\;\s*\;/\;/) {}        
# replaces white space-separated ; by a single ;
$code_unit =~ s/= *0 *; *$//; # removes = 0 ;
$code_unit =~ s/\; *$//; # remove last semicolon if only followed by whitespace
if ($code_unit =~ /\;([^\;]*)$/) {
  &print_warning("code unit contains several function definitions. " .
                 "I extracted\n $1");
  $code_unit = $1;
}

# At this point we have a single function definition in code_unit
&print_debug("code unit after bracket removal=$code_unit"); #DEBUGOUT


#line 2130 "ext.nw"
$code_unit =~ s/const *$//;  # remove const qualifier at end
$code_unit =~ s/::/doppeldoppel/g;  # replace :: by doppeldoppel
$code_unit =~ s/\) *:.*$/\)/;    # remove initialization constructor call
$code_unit =~ s/doppeldoppel/::/g;   # reintroduce ::
$code_unit  =~ s/(^|\W+)virtual(\W+)/$1$2/;             # remove blanks virtual blanks      
$code_unit  =~ s/(^|\W+)friend(\W+)/$1$2/;              # remove friend
$code_unit  =~ s/(^|\W+)inline(\W+)/$1$2/;              # remove inline
$code_unit  =~ s/(^|\W+)extern(\W+)/$1$2/;              # remove extern
$static = ($code_unit  =~ s/(^|\W+)static(\W+)/$1$2/);  #remove static and record
$enum   = ($code_unit  =~ s/(^|\W+)enum(\W+)/$1$2/);     #remove enum
$typedef = ($code_unit  =~ s/(^|\W+)typedef(\W+)/$2/); #remove typedef
if ($code_unit =~ s/(^|\W+)template *<([ ,\w]*)>/$1/ ) 
{ $templatelist = $2; } # remove template definition
$localclass = ($code_unit  =~ s/(^|\W+)class(\W+.*)/$2/); #remove class
&apply_Msubst(*code_unit);
&print_debug("code unit after qualifier removal=$code_unit"); #DEBUGOUT


#line 2168 "ext.nw"
  $conversion = ($code_unit =~ /operator\s*\w+\s*\(\s*\)/); 
  if ($code_unit =~ /\( *\) *\(.*\)/) { 
    $code_unit =~ s/\( *\) *\((.*)\)//; 
    $par_list = $1;
  } else { 
    $code_unit =~ s/\((.*)\)//; 
    $par_list = $1;
  }

  $operator = (($code_unit =~ /operator/) && !$conversion);  # symbol operator
  $destructor = ($code_unit =~ /^ *\~/);

  &remove_enclosing_blanks($code_unit); # I do anchored matches below

  &print_debug("code unit after first clean-up=$code_unit");
  &print_debug("par_list = $par_list");

extraction:
{ if ($destructor) { last extraction; }
 
  if ($conversion) {    # a conversion function: operator type
    if (!($code_unit =~ s/ *operator *//)) {
      &print_warning("expected a conversion function");
    }
    $fname = $code_unit;
    last extraction;
  }

  if ($operator) { # an operator: type operator opsymbol  
    $code_unit =~ /^(.*) *operator *(.*)$/;
    $type = $1;
    $fname = $2;
    last extraction;
  }
  
#line 2222 "ext.nw"
if ( $code_unit eq $Mtype ) 
{ $constructor = 1; }
elsif ( $currentsection ne "types" ) {
  # a function
  if ($code_unit =~ /^([:\w]+)$/ ) {
    $type = "int";
    $fname = $code_unit;
  } else { 
    &print_debug("proper function $code_unit");
    $code_unit =~ /^(.*[^\:\w])([\:\w]+)$/ ;
    $type = $1; 
    $fname = $2;
    &print_debug("proper function $type $fname");
    while ($type =~ s/^ //) {}
    while ($type =~ s/ $//) {} # remove beginning and trailing blanks
    if (($type =~ /^\s*const/) 
        && ($constref eq "no")) {  # remove const & bracket
      $type =~ s/^\s*const//; 
      $type =~ s/ *\& */ /;
    }
    $type =~ s/ *\& */\& /g;
    &print_debug("proper function $type $fname");
  }
}


#line 2203 "ext.nw"
}    

#line 2257 "ext.nw"
&remove_enclosing_blanks($type);
&remove_enclosing_blanks($fname);
&remove_enclosing_blanks($Mvar);
&remove_enclosing_blanks($Mtype);
&remove_enclosing_blanks($command);

#line 2272 "ext.nw"
@params = split(/,/,$par_list);  # split at commas
$par_list = "";
$i = 0;
while ($i <= $#params) {
  $j = $i + 1;
  while ($params[$i] =~ /</  && !($params[$i] =~ /\(.*<.*\)/) &&
         (($params[$i]=~tr/</</) > ($params[$i]=~tr/>/>/))) {
    # append all comma separated parameter parts together
    # as part of a template type list or comma separated
    # init parts, the second condition allows initialization
    # by bracketed expressions containing < or <<
    $params[$i] .= "," . $params[$j]; $j++;
  }
  if (($params[$i] =~ /const .*\&/) && ($constref eq "no")) {
    $params[$i] =~ s/ *const //;
    $params[$i] =~ s/ *\& */ /; # replace blanks&blanks by a single blank
    # $params[$i] =~ s/\&//;     simply remove & if not followed by a blank.
  }
  &remove_enclosing_blanks($params[$i]);
  $params[$i] =~ s/ *\& */\& /g;

  if ($i > 0) {$par_list .= "\, ";}
  $par_list .= $params[$i];
  $i = $j;
}

$varname = $Mvar;
$signature = $fname . "(" . $par_list . ")";

if ( !$showsem ) { $Mcomment = ""; }
&subst_vars(*Mcomment);

if ($command =~ /^enum$/) {
  
#line 2634 "ext.nw"
if ( !$enum ){ &print_warning("Enum should start with keyword enum"); }
$code_unit =~ s/^ *(\w*)//;    # remove blanks type blanks {
$type = $1;
$enumconsts =~ s/\s*//g;
$enumconsts =~ s/,/, /g;
if ($filter eq "all" || $filter eq $currentsection || 
    $type =~ /$filter/ || $enumconsts =~ /$filter/ ) {
  &print_enum($mode,$Mname,$type,$enumconsts,$Mcomment);
}

#line 2305 "ext.nw"
            
  last switch;
}
if ($command =~ /^type/) {
  
#line 2606 "ext.nw"
if ( $typedef ) {
  $code_unit =~ s/typename//g;
  if ( $code_unit =~ /<.*>/ ) {
    $code_unit =~ s/^ *(.*\>\S*) +(\S*)//; 
    $type = $2; 
  }
  else {
    $code_unit =~ s/^ *(\S*) +(\S*)//;
    $type = $2; 
  }
}
elsif ($localclass) {
  $type = $code_unit;
}
else 
{ &print_warning("Type member should be a typedef or a class"); }
if ($filter eq "all" || $filter eq $currentsection || 
    $fname =~ /$filter/ ) {
  &print_typemember($Mname,$type,$Mcomment);
}


#line 2309 "ext.nw"
                  
  last switch;
}
if ($command =~ /^event$/) {
  
#line 2648 "ext.nw"
$code_unit =~ /^\s*\w+\<(.*)\>\s*(\w+)/;
$par_list=$1;
$fname = $2;
my $scoper;
if ($static) { $scoper = $Mname."::"; }
else { $scoper = $Mvar."."; }
if ($filter eq "all" || $filter eq $currentsection || 
    $fname =~ /$filter/ ) {
  &print_event($scoper,$fname,$par_list,$Mcomment);
} 

#line 2313 "ext.nw"
             
  last switch;
}
if ($command =~ /^opl?$/) {
  
#line 2373 "ext.nw"
if ($operator || $constructor || $conversion || $static) {
 &print_warning("Mop applies only to member functions " .
	        "and not to operators,...");
}
if ($filter eq "all" || $filter eq $currentsection || 
    ($fname =~ /$filter/)) {
  &create_indexentry( $mode, &short_prototype($fname,$par_list), "local");
  &print_function($mode,$type,$signature,$Mcomment,
		  "$Mvar\.",$fname,$par_list); 
}

#line 2317 "ext.nw"
          
  last switch;
} 
if ($command =~ /^funcl?$/) {
  
#line 2387 "ext.nw"
if ($operator || $constructor || $conversion || $static) {
  &print_warning("Mfunc applies only to functions " .
	         "and not to operators,... ");
}
if ($filter eq "all" || $filter eq $currentsection || 
    ($fname =~ /$filter/) ) {
  &create_indexentry( $mode, &short_prototype($fname,$par_list), "global");
  &print_function($mode,$type,$signature,$Mcomment,"",$fname,$par_list); 
}
     
#line 2321 "ext.nw"
            
  last switch;
}
if ($command =~ /^binopl?$/) {
  
#line 2401 "ext.nw"
if (! $operator) {
  &print_warning("Mbinop applies only to operators");
}
$Mreplace = $Mname . " ";
if ($partypes eq "no") {
  while ($par_list =~ /$Mreplace/) { $par_list = $` . $';} 
}    

$signature = $Mvar. " " . $fname . " " . $par_list;
if ($filter eq "all" || $filter eq $currentsection || 
    $filter eq ("operator" . $fname) ){
  &print_function($mode,$type,$signature,$Mcomment);
}


#line 2325 "ext.nw"
             
  last switch;
}
if ($command =~ /^binopfuncl?$/) {
  
#line 2420 "ext.nw"
if (! $operator) {
  &print_warning("Mbinopfunc applies only to operators");
}
$Mreplace = $Mname . " ";
if ($partypes eq "no") {
  while ($par_list =~ /$Mreplace/) { $par_list = $` . $'; } 
}        
$par_list =~ s/\, / $fname /;
$signature = $par_list;
if ($filter eq "all" || $filter eq $currentsection || 
    $filter eq "operator".$fname) {
  &print_function($mode,$type,$signature,$Mcomment);
}

#line 2329 "ext.nw"
                 
  last switch;
}
if ($command =~ /^arropl?$/) {
  
#line 2439 "ext.nw"
if (! $operator) {
  &print_warning("Marrop applies only to operators");
}
$signature = $varname . "\[" . $par_list . "\]";
if ($filter eq "all" || $filter eq $currentsection ||
    $filter eq "arrop" ) {
  &print_function($mode,$type,$signature,$Mcomment);
}

#line 2333 "ext.nw"
             
  last switch;
}
if ($command =~ /^funopl?$/) {
  
#line 2451 "ext.nw"
if (! $operator) {
  &print_warning("Mfunop applies only to operators");
}
$signature = $varname . "\(" . $par_list . "\)";
if ($filter eq "all" || $filter eq $currentsection || 
    $filter eq "funop" ) {
  &print_function($mode,$type,$signature,$Mcomment);
}

#line 2337 "ext.nw"
             
  last switch;
}
if ($command =~ /^funobjl?$/) {
  
#line 2579 "ext.nw"
if ($operator || $conversion || $static) {
  &print_warning("Mfunobj applies only to function objects " .
	         "and not to operators,...");
}
$prefix = "";
$funcname = $fname;
$postfix = $par_list;
if ( $Mcomment =~ /\s*\{([^\}]*)\}/ ) {
  $type = $1;
  $Mcomment = $';
} 
$signature = $Mname."(".$par_list.")";
if ($filter eq "all" || $filter eq $currentsection ||
    $filter eq "funobj" ) {
  &print_constructor($mode,$type,$Mname,$par_list,$Mcomment); 
}


#line 2341 "ext.nw"
              
  last switch;
}
if ($command =~ /^unopl?$/) {
  
#line 2466 "ext.nw"
if (! $operator) {
  &print_warning("Munop applies only to operators");
}
unopcases: {
  if ($fname eq "->") {
    $signature = $varname . $fname;   # -> is postfix
    last unopcases;
  }
  if ($fname eq "new" || $fname eq "delete" ) {
    $signature = $fname . ' ' . $varname;  # new and delete are prefix
    last unopcases;
  }
  if ($par_list) {
    $signature = $varname . $fname; # postfix ++ and --
    last unopcases;
  }       
  $signature = $fname . $varname; # all others are prefix operators 
}

if ($filter eq "all" || $filter eq $currentsection || 
    $filter =~ /$fname/ || $filter eq ("operator" . $fname )) {
  &print_function($mode,$type,$signature,$Mcomment);
}

#line 2345 "ext.nw"
            
  last switch;
}
if ($command =~ /^unopfuncl?$/) {
  
#line 2497 "ext.nw"
if (! $operator) {
  &print_warning("Munop applies only to operators");
}
     
unopfunccases: {
  if ($fname eq "->") {
    $signature = $varname . $fname;   # -> is postfix
    last unopfunccases;
  }
  if ($fname eq "new" || $fname eq "delete" ) {
    $signature = $fname . ' ' . $varname;  # new and delete are prefix
    last unopfunccases;
  }
  if ($par_list =~ /,/) {
    $signature = $varname . $fname; # postfix ++ and --
    last unopfunccases;
  }       
  $signature = $fname . $varname; # all others are prefix operators 
}

if ($filter eq "all" || $filter eq $currentsection ||
    $filter =~ /$fname/ || $filter eq ("operator" . $fname )) {
  &print_function($mode,$type,$signature,$Mcomment);
}

#line 2349 "ext.nw"
                
  last switch;
}
if ($command =~ /^staticl?$/) {
  
#line 2526 "ext.nw"
if (!$static) {
  &print_warning("Mstatic applies only to static member functions");
}
     
if ($filter eq "all" || $filter eq $currentsection || 
    ($fname =~ /$filter/)) {
  &create_indexentry( $mode, &short_prototype($fname,$par_list), "local");
  &print_function($mode,$type,$signature,$Mcomment,"$Mname\:\:",$fname,$par_list);
}

#line 2353 "ext.nw"
              
  last switch;
}
if ($command =~ /^conversion/) {
  
#line 2542 "ext.nw"
if (!$conversion) {
  &print_warning("Mconversion applies only to conversion operators");
}
if ($filter eq "all" || $filter eq $currentsection ){
  &print_function($mode,$type,$signature,$Mcomment,"",$fname,$Mvar);
}

#line 2357 "ext.nw"
                  
  last switch;
}
if ($command =~ /^create/) {
  
#line 2553 "ext.nw"
if (!$constructor) {
  &print_warning("Mcreate applies only to constructors");
}
if ($filter eq "all" || $filter eq $currentsection ) {
  &print_constructor($mode,$Mname,$Mvar,$par_list,$Mcomment);
}

#line 2361 "ext.nw"
              
  last switch;
}
if ($command =~ /^destruct/) {
  
#line 2564 "ext.nw"
if (!$destructor) {
  &print_warning("Mdestruct applies only to destructors");
}
if ($filter eq "all" || $filter eq $currentsection ){ 
  &print_destructor($mode,$Mname,$Mcomment);
}

#line 2365 "ext.nw"
                
  last switch;
}

 

#line 1540 "ext.nw"
  &print_warning( "did not recognize command name M" . $command);
}

#line 1380 "ext.nw"
redo main_loop;
}


#line 2959 "ext.nw"
if    ($mode eq "Fman" ) { exit; }
elsif ($mode =~ /HTML/) {
  &closetabular();
  if ($mode eq "HTMLman") { print_unit("\\end{document}"); }
}
elsif ($mode eq "Lman") {
  print_unit("\\end\{manual\}\n\\end{document}");          
  close OUTPUT;
  $owd = $ENV{"PWD"};
  if ($latexruns == 0) { exit; }
  chdir ("/tmp");
   
  &print_info("Preparing manual page with LaTeX...");

  if ($outfile ne "/tmp/$pid-ext.tex") {
    if ($outfile =~ /\//) # absolute path name 
    { system("cp $outfile /tmp/$pid-ext.tex");}
    else 
    { system("cp $owd/$outfile /tmp/$pid-ext.tex");}
  }

  system ("latex /tmp/" . $pid . "-ext.tex" . $dontshowinfo);
  if ($latexruns == 2) {
    system ("latex /tmp/" . $pid . "-ext.tex" . $dontshowinfo);
  }

  if ($xdvi eq "yes") {
    &print_info("Starting xdvi previewer...");
    system ("xdvi -s 3 /tmp/" . $pid . "-ext.dvi" . $dontshowinfo);
  }
  elsif ($dvioutfile ne "") {
    &print_info("Copying dvi file into file $dvioutfile in working directory...");
    system("cp /tmp/$pid-ext.dvi $owd/$dvioutfile");
  }
  else {
    &print_info("Copying dvi file into file $basename.dvi in working directory...");
    system("cp /tmp/$pid-ext.dvi $owd/$basename.dvi");
  }

  system("rm -f /tmp/" . $pid . "-ext.*");
  chdir ("$owd");
}
elsif ($mode eq "Mkman" || $mode eq "lextract") {
  print_unit("\\end{manual}");
}
elsif ($mode eq "Ldoc") {
  close OUTPUT;
  open OUTPUT , ">>/tmp/$pid-ext.tex";
  print OUTPUT "\\end{manual}\n"; 
  close(OUTPUT); 

  &print_info("  Created $basename.man");
  &print_info("Removing the manual comments (except for Mpreamble)".
	      " from $INPUT...");

  $tempfile = "/tmp/" . $pid . "-$basename";
  if ($delman eq "refined") {
    system("ext_ldel $INPUT $tempfile.$ext");
    &print_info("  Created $tempfile.$ext through ext_ldel");
  }
  if ($delman eq "yes" || $kind eq "Cweb") {
    if ($delman eq "no") 
    { &print_info("Option delman=no not implemented for Cweb");}
    system("ldel $INPUT $tempfile.$ext");
    &print_info("  Created $tempfile.$ext through ldel");
  }
  if ($delman eq "no" && $kind ne "Cweb") {
    system("cp  $INPUT $tempfile.$ext"); 
    &print_info("  Created $tempfile.$ext by copying");
  }

  system("mv /tmp/$pid-ext.tex $basename.man");  # move manpage
  &print_info("Calling $kind weave on $tempfile.$ext...");
  # cweave produces its output in the working directory
  # lweave produces its output in the directory of the input
  # noweave produces its output on standard output
  if ($kind eq "Cweb") {
    system( "cweave $tempfile.$ext");
    system( "mv $pid-$basename.scn $basename.scn");
    system( "mv $pid-$basename.idx $basename.idx");
    system( "mv $pid-$basename.tex $basename.tex");
  }
  elsif ($kind eq "Lweb") {
    system( "lweave $tempfile $noweaveoptions");
    system( "mv $tempfile.tex $basename.tex");
    system( "mv $tempfile.nw $basename.nw");
  }
  elsif ($kind eq "noweb") {
    system("noweave -delay $noweaveoptions $tempfile.nw > $basename.tex");
  }

  &print_info("  Created $basename.tex");
  if ($latexruns == 0) {exit;}
  &print_info("Calling latex...");
  system("latex $basename.tex $dontshowinfo");
  if ($latexruns == 2) {
    system("latex $basename.tex $dontshowinfo");
  }
  if ($xdvi eq "yes") {
    &print_info("Starting xdvi previewer...");
    system("xdvi -s 3 $basename.dvi $dontshowinfo");
  }
  system("rm -f /tmp/$pid*");

}


#line 1792 "ext.nw"
sub create_indexentry {	
  my ($mode,$entry,$scope) = @_;
  if ($indexing eq "yes") {
    if ( $mode =~ /HTML/ ) { 
      if ($scope eq "local")  
      { $indexentry .= "\\index\{$entry\!$MIname\}\n"; }
      else { $indexentry .= "\\index\{$entry\}\n"; }
    } else { # latex like
      if ($scope eq "local")  
      { $indexentry .= "\\index\{".&convert_R($entry)."\!".
	               &convert_MI($MIname)."\}\n"; }
      elsif ($scope eq "global") 
      { $indexentry .= "\\index\{".&convert_R($entry)."\}\n"; }
      else # class symbol
      { $indexentry .= "\\index\{".&convert_MI($entry)."\}\n"; }
    }
  }
}

sub short_prototype {
  local($proto) = shift(@_);
  if ($proto eq "") { return ""; }
  local($params) = shift(@_);
  if (length($proto) > 20) 
  { $proto = substr($proto,0,17) . "..."; }
  $proto = &convert_R($proto);
  if ($params) { $proto.="(...)"; } 
  else { $proto.="()"; }
  $proto;
}


sub print_unit {
   local($text) = @_; # read argument into local variable
   if ($indexentry ne "") { 
     chop $indexentry;
     $text .= "\n" . $indexentry;
     $indexentry=""; 
   } 
   if ( $text ne "" ) { $text .="\n\n"; }
   if ( $mode ne "Fman" ) { print OUTPUT $text; }
   else { print STDOUT $text; }
}


# the following is only used in HTML mode:

sub print_table_row {
  my @params = @_;
  my $row = "";
  #if ($indexentry ne "") { chop $indexentry; }
  foreach $i (0 .. $#params) {
    if ($params[$i] eq "") { $row.="\\ "; }
    else { $row.=$params[$i]; }
    if ($i == 0) { $row .= $indexentry; }
    if ($i == $#params) { $row .= " \\\\";} 
    else { $row .= " \& "; }
    # was { $row .= "\n" .$indexentry . " \\\\";}
  }
  if ($indexentry ne "") {  $indexentry=""; } 
  print OUTPUT $row , "\n";
}

#the following is only used in HTML mode:
sub multicol {
  my $colnum = shift(@_);
  my $content = shift(@_);
  my $line = "\\multicolumn\{$colnum\}\{l\}\{ ".$content."\}";
  $line;
}


#line 1878 "ext.nw"
# we expect that placeholder substitution already took place
sub convert_to_LaTeX {
  local($text) = @_; # read argument into local variable
  if ($text eq "") { return ""; }
  local($output) = "";
  local($inverb) = 0;
  while ($text) { 
    $text =~ /^([^\n]*\n)/;
    $text = $';
    $currline = $1;
    if ( $currline =~ s/\\begin\{Mverb\}/\\begin\{verbatim\}/ ) {
      $inverb = 1; $output .= $currline;
    }
    elsif ( $currline =~ s/\\end\{Mverb\}/\\end\{verbatim\}/ ) {
      $inverb = 0; $output .= $currline;
    }
    elsif ( $inverb ) {
      $output .= $currline;
    }
    else {
      $output .= &convert_line($currline);
    }
  } 
  $text = $output;
  if ($kind eq "Cweb") {
    
#line 1912 "ext.nw"
local($i, $remline, $outline, $lines , $word); 
@lines = split(/^/,$text);  # split at new lines
$text = "";
foreach $i (0 .. $#lines) {
  if (length($lines[$i]) > 80) {
     $outline = "";
     $remline = $lines[$i];
     while ($remline ) {
       if ($remline =~ /[\w\,] /) 
       { $word = $` . $&; $remline = $'; }
       else 
       { $word = $remline; $remline = ""; }
       # a word charachter or komma followed by a blank or the entire line
       if (length($outline) + length($word) < 80)
       { $outline  .= $word; }
       else { 
         if ($outline) 
         { $text .= $outline . "\n"; }
         else { 
           &print_warning("unable to break line, " .
	   "might cause trouble with cweave\n$word\n\n");
         }
         $outline = $word;
       }
     }
     $text .= $outline;   # no newline here
   }
   else 
   { $text .= $lines[$i]; }   # no newline here
}  


#line 1903 "ext.nw"
                                           
  }
  $text;
}


#line 3184 "ext.nw"
sub convert_line{
  local($text) = @_; # read argument into local variable
  local($output) = "";
  local($lastchar) = chop($text);
  if ($lastchar eq "\n" || $lastchar eq "\r") { }
  else { $text .= $lastchar; }  #last line of text maybe without linefeed 
iteration:
  while ($text) {
    if ($text =~ /^([^\\\[\|]+)/) { # does not start with [ or | or \
      $text = $';
      $output .= $1;
      if ($text eq "") { last iteration; }
    } 
    # text is nonempty and starts with [ or | or \       
    if ($text =~ /^\\Mcode(.)/) {
      $text = $';
      $delimiter=$1;
      if (!($text =~ /\\$1/))  # \ to protext meta characters
      { &print_warning("Mcode extends beyond end of line"); }
      $text = $';
      $output .= &convert_M($`);
      next iteration;
    }
    if ($text =~ /^\\Tcode(.)/) {
      $text = $';
      $delimiter=$1;
      if (!($text =~ /\\$1/))  # as above
      { &print_warning("Tcode extends beyond end of line"); }
      $text = $';
      $output .= &convert_T($`);
      next iteration;
     }
    # next we deal with | in its exceptional meanings
    if ($text =~ /^\\begin\{tabular\}[^\{]*\{[^\}]*\}/) {
      $output .= $text;
      last iteration;
    }     
    if ($text =~ /^\\left\|/) {
      $text = $';
      $output .= "\\left\|";
    }
    if ($text =~ /^\\right\|/) {
      $text = $';
      $output .= "\\right\|";
    }
    if ($text =~/^\|\|/) {
      $text = $';
      $output .= "\|\|";
    } 
    if ($text =~ /^\|/) {
      $text = $';
      if (!($text =~ /\|/)) 
      { &print_warning("odd number of |:\n|$text\n\n"); }
      $text = $';
      $output .= &convert_M($`);
      next iteration;
    }
    if ($text =~ /^\[\[/) {
      $text = $';
      if (!($text =~ /\]\]/))
      { &print_warning("encountered [[ without matching ]]:[[$text\n\n"); }
      $code = $`;  
      $text = $';
      while ($code =~ /\]\]/) {
        $code = $`;
        $text = $' . "]]" . $text;
      }
      $output .= &convert_T($code);;
      next iteration;
    }
     
    # text does not start with a special symbol. Move first symbol to output.
    $text =~ /^(.)/;
    $output .= $1;
    $text = $';
  }
  return $output . "\n";
}

         

#line 3322 "ext.nw"
# the following procedure is copied from ext.nw. Please make changes only here.
# I still need a way to maintain consistency with ext.

sub convert_M {
 local($Ctext) = @_; # read argument into local variable
 # we first work on identifiers 
 &print_debug("convert_M $Ctext\n");
 if ($Ctext eq "") { return ""; }
 local($prefix) = "";
 local($suffix) = $Ctext;
 local($ident) = "";

identloop:
  while ($suffix =~ /^(\W*)(\w.*)$/) {
    $prefix .= $1;
    $suffix = $2;
    if ( $suffix =~ /^(\w+)(\W.*)$/ ) {
      $ident = $1;
      $suffix = $2;
    } else { 
      $ident = $suffix;
      $suffix = "";
    }
    if ($prefix =~ /\\$/) { # For things like \n
      if ($ident ne "n") 
      { &print_warning("Huch:\\ in  quoted code:\n".$Ctext); }
      $prefix .= "L" . $ident; next identloop;
    }
    if ($ident =~ /^[0-9]*$/ ) # just a number
    { $prefix .= $ident; next identloop; }
    if (($usesubscripts eq "yes") && ($ident =~ /^([a-zA-Z])([0-9]+)$/)) 
    { $ident = $1 ."\\underscore\{$2\}"; }
    elsif ( length($ident) > 1 ) 
    { $ident = "\\mathit\{$ident\}"; }
    $prefix .= $ident;
  }
  $Ctext = $prefix . $suffix;
  $Ctext =~ s/&/\\&/g;
  $Ctext =~ s/_/\\nspaceunderscore\\_/g; # small negative space before _
  $Ctext =~ s/\./\\nspacedot\./g;  # small negative space before .
  $Ctext =~ s/::/\\DP /g;
  $Ctext =~ s/<</\\ll/g;
  $Ctext =~ s/>>/\\gg/g;
  $Ctext =~ s/ *<= */\\Lle/g;
  $Ctext =~ s/ *>= */\\Lge/g;
  $Ctext =~ s/ *== */\\Leq/g;
  $Ctext =~ s/ *-> */\\Larrow/g;
  $Ctext =~ s/ *\+ */+/g;   # LaTeX takes care of the spacing
  $Ctext =~ s/ *- */-/g;
  $Ctext =~ s/ *\* +/\*/g;
  if ($Ctext =~ /<.*>/) {
    # I guess that I discovered template brackets. Therefore, I interpret
    # all brackets in the text as template brackets and I keep the spacing
    # in the input.
    $Ctext =~ s/</\\Ltemplateless/g;
    $Ctext =~ s/>/\\Ltemplategreater/g;
  } else {
    # there are no template brackets. I interpret < and > as in Latex and 
    # leave the spacing to LATEX
    $Ctext =~ s/ *< */</g;
    $Ctext =~ s/ *> */>/g;
  }
  $Ctext =~ s/ *\+= */\\Lass\{\+\}/g;
  $Ctext =~ s/ *\-= */\\Lass\{\-\}/g;
  $Ctext =~ s/ *\*= */\\Lass\{\*\}/g;
  $Ctext =~ s/ *\/= */\\Lass\{\/\}/g;
  $Ctext =~ s/ *\\&= */\\Lass\{\\&\}/g;
  $Ctext =~ s/ *!= */\\Lass\{\!\}/g;
  $Ctext =~ s/ *\|= */\\Lass\{\|\}/g;

  # All blanks that are still in Ctext are to be preserved and
  # are hence quoted.
  $Ctext =~ s/ /\\ /g;
  $Ctext =~ s/\+\+/\\Dplus /g;
  $Ctext =~ s/\-\-/\\Dminus /g;
  # $Ctext =~ s/!=/\\Noteq /g;
  $Ctext =~ s/\\Lle/\\Lle /g;
  $Ctext =~ s/\\Lge/\\Lge /g;
  $Ctext =~ s/\\Leq/\\Leq /g;
  $Ctext =~ s/\\Ltemplateless/\\Ltemplateless /g;
  $Ctext =~ s/\\Ltemplategreater/\\Ltemplategreater /g;
  $Ctext =~ s/\\Larrow/\\Larrow /g;
  $Ctext =~ s/%/\\%/g; 
  $Ctext =~ s/\^/\\circumflexop /g;
  $Ctext =~ s/~/\\tildeop /g;
  $Ctext =~ s/'/\\Lrquote /g;
  $Ctext =~ s/`/\\Llquote /g; 
  $Ctext =~ s/\(\)/\(\\;\)/g;      # a little space for empty argument list
  $Ctext =~ s/\,\\ /\,\} \\ensuremath\{/g;  
  $Ctext =~ s/\\Ltemplateless\\ /\\Ltemplateless\}\n\\ensuremath\{/g;  
  $Ctext =~ s/\\ \\Ltemplategreater/\}\n\\ensuremath\{\\Ltemplategreater/g;  
  $Ctext = "\\ensuremath\{" . $Ctext . "\}";
  #$Ctext =~ s/\,\\ /\,\$\}\n\\mbox\{\$/g;  
  #$Ctext =~ s/\\Ltemplateless\\ /\\Ltemplateless\$\}\n\\mbox\{\$/g;  
  #$Ctext =~ s/\\ \\Ltemplategreater/\$\}\n\\mbox\{\$\\Ltemplategreater/g;  
    # separate mbox at ,blank OR <blank OR blank> by $}newline\mbox{$ 
     # to allow better line breaks
  #$Ctext = "\\mbox\{\$" . $Ctext . "\$\}";
  &print_debug("convert_M $Ctext\n");
  $Ctext;
}

#line 3428 "ext.nw"
# the following operation does just a roman typesetting of code text

sub convert_R {
  local($romantext) = @_;
  $romantext =~ s/([^\\])\_/$1\\nspaceunderscore\\_/g;
  $romantext;
}

# math like style for index
sub convert_MI {
  local($indexentry) = @_;
  $indexentry .= '@' . &convert_M($indexentry); 
  # this makes entry the key and the second the look of it
  $indexentry;
}

# ascci text formatting
sub convert_to_ASCII {
  local($text) = shift(@_);
  if ($text eq "") { return ""; }
  # $text = &convert_quoted_code_for_HTML($text);
  $text = &remove_confusing_latex($text);
  local($left) = shift(@_);
  local($cols) = shift(@_);
  local($indent);
  for (1 .. $left) { $indent.=' '; }
  local($result) = "";
  $text =~ s/\n\n/\\\\/g;
  $text =~ s/\n/\ /g;
  $text =~ s/\s+/\ /g; 
  $text =~ s/^\s*//g;
  local($line)=$indent; 
  local($rest)="";
  getloop: {
    if ($text =~ s/(\S+\s+)//) { $rest .= $1; }
    else { last getloop; }
    if (length($line.$rest) < $cols) 
    { if ( $rest =~ /\\\\\s*/ ) { $line .= $`; $rest = $'; }
      else { $line .= $rest; $rest=""; redo getloop; }
    }
    $result .= $line."\n"; $line=$indent;
    redo getloop;
  }
  $line .= $rest;
  if ($line ne "") { $result .= $line; } 
  else { chop $result; }
  $result;
}




#line 3486 "ext.nw"
# the following procedure is copied from ext.nw. Please make changes only here.
# I still need  way to maintain consistency with ext.

sub convert_T{
 local($Ctext) = @_; # read argument into local variable
 $Ctext =~ s/&/\\&/g;
 $Ctext =~ s/_/\\_/g;
 $Ctext =~ s/{/\\{/g;
 $Ctext =~ s/}/\\}/g;
 $Ctext =~ s/%/\\%/g; 
 $Ctext =~ s/\^/\\circumflexop /g;
 $Ctext =~ s/~/\\Tildeop /g; 
 return "\{\\tt " . $Ctext . "\}";
}


#line 3509 "ext.nw"
sub convert_to_HTML{
    &print_debug("convert_to_HTML $Ctext\n");
 local($Ctext) = @_; # read argument into local variable
 $Ctext =~ s/\\begin\{Mverb\}/\\begin\{verbatim\}/g;
 $Ctext =~ s/\\end\{Mverb\}/\\end\{verbatim\}/g;
 $Ctext = &convert_quoted_code_for_HTML($Ctext);
 $Ctext = &convert_math_for_HTML($Ctext);
 $Ctext = &deal_with_refs($Ctext);
 return $Ctext;
}


#line 3539 "ext.nw"
sub convert_quoted_code_for_HTML {
  local($text) = @_; # read argument into local variable
  local($output) = "";
  $text =~ s/\n/LEDANEWLINE/g;

iteration:
   while ($text)
    { if ($text =~ /^([^\\\[\|]+)/)  # does not start with [ or | or \
        { $text = $';
          $output .= $1;
          if ($text eq "") { last iteration;}
        } 
      # text is nonempty and starts with [ or | or \       
      if ($text =~ /^\\Mcode(.)/)
       { $text = $';
         $delimiter=$1;
         if ( !($text =~ /\\$1/ ))  # \ to protect meta characters
         { &print_warning("Mcode extends beyond end of line"); }
         $text = $';
         $output .= &convert_M_for_HTML($`);    
         next iteration;
       }
      if ($text =~ /^\\Tcode(.)/)
       { $text = $';
         $delimiter=$1;
         if (!($text =~ /\\$1/))  # as above
         { &print_warning("Tcode extends beyond end of line"); }
         $text = $';
         $output .= &convert_T($`);
         next iteration;
       }
      # next we deal with | in its exceptional meanings
      if ($text =~ /^\\begin\{tabular\}[^\{]*\{[^\}]*\}/)
       {  $output .= $text;
          last iteration;
       }     
      if ($text =~ /^\\left\|/)
       { $text = $';
         $output .= "\\left\|";
       }
      if ($text =~ /^\\right\|/)
       { $text = $';
         $output .= "\\right\|";
       }
      if ($text =~ /^\|/)
       { $text = $';
         if (!($text =~ /\|/)) 
	 { &print_warning("odd number of |:\n|$text\n\n"); }
         $text = $';
         $output .= &convert_M_for_HTML($`);
         next iteration;
       }
      if ($text =~ /^\[\[/)
       { $text = $';
         if (!($text =~ /\]\]/))
         { &print_warning("encountered [[ without matching ]]:[[$text\n\n"); }
         $code = $`;  
         $text = $';
         while ($code =~ /\]\]/)
           { $code = $`;
             $text = $' . "]]" . $text;
           }
         $output .= &convert_T($code);;
         next iteration;
       }
     
      # text does not start with a special symbol. Move first symbol to output.
      $text =~ /^(.)/;
      $output .= $1;
      $text = $';
    }
  $output =~ s/LEDANEWLINE/\n/g;
  return $output ;
}

sub old_convert_M_for_HTML {
  local($text) = @_;
  $text =~ s/_/\\_/g;
  $text =~ s/&/\\&/g;
  return $text;
}


sub convert_M_for_HTML {
 local($Ctext) = @_; # read argument into local variable
    &print_debug("convert_M_for_HTML $Ctext\n");
 # we first work on identifiers 
 if ($Ctext eq "") { return ""; }
 local($prefix) = "";
 local($suffix) = $Ctext;
 local($ident) = "";

identloop:
  while ($suffix =~ /^(\W*)(\w.*)$/) {
    $prefix .= $1;
    $suffix = $2;
    if ( $suffix =~ /^(\w+)(\W.*)$/ ) {
      $ident = $1;
      $suffix = $2;
    } else { 
      $ident = $suffix;
      $suffix = "";
    }
    if ($prefix =~ /\\$/) { # For things like \n
      if ($ident ne "n") 
      { &print_warning("Huch:\\ in  quoted code:\n".$Ctext); }
      $prefix .= "L" . $ident; next identloop;
    }
    if ($ident =~ /^[0-9]*$/ ) # just a number
    { $prefix .= $ident; next identloop; }
    if (($usesubscripts eq "yes") && ($ident =~ /^([a-zA-Z])([0-9]+)$/)) 
    { $ident = $1 ."\\HTML\{SUB\}\{$2\}"; }
    else 
    { $ident = "\\HTML\{I\}\{$ident\}"; }
      
    $prefix .= $ident;
  }

  # All blanks that are still in Ctext are to be preserved and
  # are hence quoted.
  $Ctext = $prefix . $suffix;
  $Ctext =~ s/&/\\&/g;
  $Ctext =~ s/_/\\_/g;
  $Ctext =~ s/\%/\\%/g; 
  $Ctext =~ s/\#/\\#/g; 
  $Ctext =~ s/~/\$\\sim\$/g;
  $Ctext =~ s/\^/\$\\circumflexop\$/g;
  $Ctext;
}



#line 3699 "ext.nw"
sub convert_math_for_HTML {
 local($Ctext) = @_; 
 $Ctext =~ s/\n/LEDANEWLINE/gi;

 # section to 
 if ( $Ctext =~ /array/  || $Ctext =~ /tabular/ ) {
   local($unprocessed) = $Ctext;
   local($transformed) = "";
   while ( $unprocessed =~ s/\\end\{([^\}]*)\}(.*)// ) {
     local($latexenv) = $1;
     local($rest) = $2;
     if ( $latexenv =~ /array/ || $latexenv =~ /tabular/ ) { 
       local($lenv) = $latexenv; $lenv  =~ s/\*/\\\*/; # escape * environments
       $unprocessed =~ s/\\begin\{$lenv\}(.*)//e;
       local($between) = $1;
       # now $unprocessed $between $rest is the whole line
       $between =~ s/\\\\/LEDAARRAYNL/gi;
       $transformed .= ($unprocessed . "\\begin{$latexenv}" . $between .
                        "\\end{$latexenv}");
       $unprocessed = $rest;
     }
     else {
       $transformed .= ($unprocessed . "\\end{$latexenv}");
       $unprocessed = $rest;
     }
   }
   $Ctext = $transformed . $unprocessed;
 }

 # section to transform displaymath to a ensured picture in regular math:
 if ( $Ctext =~ s/\\\[(.*?)\\\]/\n\\begin\{makeimage\}\n\$$1\$\n\\end\{makeimage\}\n/g ||
      $Ctext =~ s/\$\$(.*?)\$\$/\n\\begin\{makeimage\}\n\$$1\$\n\\end\{makeimage\}\n/g) {
   &print_warning("I encountered displayed mathematics. ".
		  "I replaced it by ordinary math mode.");
 }

 local($unprocessed) = $Ctext;
 $Ctext = "";
 
 while ( $unprocessed =~ /^([^\$]*)\$([^\$]*)\$(.*)$/s ) {
     # text contains two or more dollars
     $Ctext .= &quote_special_symbols_in_text_mode($1);
     local($math) = $2;
     $unprocessed = $3;
     $math = &simplify_math_for_HTML($math); 
     $Ctext .= "\$" . $math . "\$";
 }
 $Ctext .= &quote_special_symbols_in_text_mode($unprocessed);
 $Ctext =~ s/LEDANEWLINE/\n/gi;
 $Ctext =~ s/LEDAARRAYNL/\\\\/gi;
 return $Ctext;
}

# the following operation replaces the texreplacementtable
#line 3788 "ext.nw"
sub simplify_math_for_HTML {
   local($math) = @_; 
   &print_debug("simplify_math_for_HTML $math\n");
   $math =~ s/\\Labs[^\{]*\{(.*?[^\\])\}/\|$1\|/gs;
   $math =~ s/\\Litem[^\{]*\{(.*?[^\\])\}/<$1>/gs;
   #$math =~ s/\\mbox[^\{]*\{(.*?[^\\])\}/$1/gs;
   $math =~ s/\\_/{\\_}/gs;
   $math =~ s/\\ / /gs;
   foreach $key (keys(%texreplacementtable)) {
     local($replacement) = $texreplacementtable{$key};
     $math =~ s/\\$key(\W|$)/$replacement$1/gs;
   }
   &print_debug("simplify_math_for_HTML $math\n");
   $math;
}

#line 3807 "ext.nw"
sub remove_confusing_latex {
   local($text) = @_; 
   $text =~ s/\\\_/\_/g;
   $text =~ s/\\\{/{/g;
   $text =~ s/\\\}/}/g;
   $text =~ s/\\ / /g;
   $text =~ s/\\\&/\&/g;
   $text =~ s/\\dots/.../g;
   $text =~ s/\\ldots/.../g;
   $text =~ s/\\pi[\W]/pi/g;
   $text =~ s/\\leq/<=/g;
   $text =~ s/\\times/ x /g;
   $text =~ s/\\le/</g;
   $text =~ s/\\geq/>=/g ;
   $text =~ s/\\ge/\>/g;
   $text =~ s/\\ne/!=/g ;
   $text =~ s/\\in/ in/g;
   $text =~ s/\\Lvert/\|/g;
   $text =~ s/\\text..\{([^\}]*)\}/$1/g;
   $text =~ s/\{\\\w{2}?([^\}]*)\}/$1/g;
   $text =~ s/\\headerline\{([^\}]*)\}/uc($1)."\n\n"/ge;
   $text =~ s/\\precond/Precondition\: /g;
   $text =~ s/\\bigskip//g;

   $text;
}


#line 3841 "ext.nw"
sub quote_special_symbols_in_text_mode {
  local($Ctext) = @_; # read argument into local variable
  # it remains to quote all special characters.
  $Ctext =~ s/\\\\/\\HTML\{BR\}\{\}/g;
  $Ctext =~ s/\\headerline/\\textbf/g;
  # starting latex2html 98.1 we can enforce a linebreak
  return $Ctext;
}



#line 3862 "ext.nw"
sub deal_with_refs{
 local($Ctext) = @_; # read argument into local variable
 while ($Ctext =~ /\\ref\{([^\}]*)\}/)
 { local($key) = $1;
   $key1 = $key; $key1 =~ s/_/\\_/g;
   $Ctext =~ s/\\ref\{$key\}/\\hyperref{$key1}{}{}{$key}/;
 }
 return $Ctext;

}



#line 3886 "ext.nw"
sub insert_URLs_and_quote{
  local($Ctext) = @_; 
  local(@fields) = split(/([\ \(\)\<\>\,\&\.\:\[\]\=\*\'])/,$Ctext);
  foreach $i (0 .. $#fields) {
    if ($fields[$i] =~ /^\w*$/) { # alphanumeric string
      local($key) = $fields[$i];
      local($label) = $namereplacementtable{$key};
      if ($label ne "" && $key ne $Mtype) {
        $key =~ s/_/\\_/g;
         $fields[$i] = "\\htmlref\{$key\}\{$label\}"; 
       }
       else {
         $key =~ s/_/\\_/g;
         $fields[$i] = $key;
       }
    }    
    else { # quote some characters
      if ($fields[$i] =~ /&/) {
        $fields[$i] = "\\$fields[$i]"; 
      }
      if ($fields[$i] =~ /</) {
        $fields[$i] = "\$<\$"; 
      }
      if ($fields[$i] =~ />/) {
        $fields[$i] = "\$>\$"; 
      }
      $fields[$i] =~ s/\\n/\$\\backslash\\mathtt\{n\}\$/g;  # takes care of \n
    }
  }
  $Ctext = join("",@fields);
  return $Ctext;
}





#line 1953 "ext.nw"
sub subst_vars {
  local(*string) = @_;
  if ($string eq "") { return; }
  $string =~ s/\\Mvar/$Mvar/g;
  $string =~ s/\\Mtype/$Mtype/g;
  $string =~ s/\\Mname/$Mname/g;
  if ($string =~ /\\var\W/ || $string =~ /Mvar/) 
  { &print_warning("found an occurrence of \\var or an unslashed ".
		   "occurrence of Mvar. Did you mean \\Mvar?"); }
  if ($string =~ /\\type\W/ || $string =~ /Mtype/) 
  { &print_warning("found an occurrence of \\type or an unslashed ".
		   "occurrence of Mtype. Did you mean \\Mtype?"); }
  if  ($string =~ /\\nameW/ || $string =~ /Mname/) 
  { &print_warning("found an occurrence of \\name or an unslashed ".
		  "occurrence of Mname. Did you mean \\Mname?"); }
}

sub apply_Msubst{
  local(*alias) = @_;
  my $i = 0;
  while ($i < @substlist)
  { $leftside =  $substlist[$i]; $i++;
    $rightside = $substlist[$i]; $i++;
    $alias =~ s/^$leftside/$rightside/g;
    $alias =~ s/([^\\])$leftside/$1$rightside/g;
    # \name can be used as an escape symbol to keep name
    $alias =~ s/\\$leftside/$leftside/g;
    # when escaping \name we delete the \ for typesetting
  }
}


#line 2707 "ext.nw"
sub print_function {

  &print_debug("print_function:".join(':',@_));
  my($mode, $type, $signature, $semantics, $prefix, $funcname, $postfix) = @_;

if ($mode eq "Fman") {
   if ($funcname) 
   { $signature = $prefix . $funcname . "(". $postfix. ")"; }
   &print_unit( $type." ".$signature );
   &print_unit(&convert_to_ASCII($semantics,5,70));
   return;
} elsif ($mode =~ /HTML/) {
  if ($funcname) 
  { $signature = $prefix . $funcname . "(". $postfix. ")"; }
  my $shortsig = ( length($signature) <= 25 );
  $type = &insert_URLs_and_quote($type);
  $signature = &insert_URLs_and_quote($signature);
  $semantics = &convert_to_HTML($semantics);
  &opentabular(3);
  if ( $shortsig ) 
  { &print_table_row($type, $signature, $semantics); }
  else {
    &print_table_row($type, &multicol(2,$signature));
    &print_table_row("","",$semantics);
  }
  return;
}

  $type = &convert_M($type);
  my $paralist = "";
  if ($funcname) {
    $funcname = &convert_M($prefix) . &convert_R($funcname);
    $paralist = &convert_M($postfix);
    if ($paralist eq "") { $paralist = "\$\\,\$"; } # small space
  } else {
    $signature = &convert_M($signature);
  }
  $semantics = &convert_to_LaTeX($semantics);

  if ( $type eq "" && $funcname eq "" && $signature =~ /\(\s*\)/ ) {
    &print_warning("I encountered an empty prototype ".
	  $signature . " and will not produce an entry.");
    return;
  }

  if ($funcname) {
      if (! ($command =~ /^opl?/ || $command =~ /^funcl?/ || $command =~ /^funobj/ ||
	     $command =~ /^staticl?/ || $command =~ /^conversion?/) )
      { &print_warning("wrong case for function print");}
    &print_unit("\\function\{$type\}\n\{$funcname\}\n".
		"\{$paralist\}\n\{$semantics\}");
  } else { 
    &print_unit("\\operator\{$type\}\n\{$signature\}\n\{$semantics\}"); 
  }
}

#line 2767 "ext.nw"
sub print_constructor {

  &print_debug("print_constructor:".join(':',@_));
  my ($mode,$Mname,$Mvar,$par_list,$semantics) = @_;

if (!$Mvar || !$Mname ) {
  &error_handler("You forgot to define either Mvar or Mname.");
}

my $signature;
if ($mode eq "Fman") {
  $signature = $Mname . " " . $Mvar;
  if ($par_list) { $signature .= " ( " . $par_list. " )"; }
  &print_unit($signature);
  &print_unit(&convert_to_ASCII($semantics,5,70));
  return;
}
if ($mode =~ /HTML/) {
  $semantics = &convert_to_HTML($semantics); 
  my ($sig1,$sig2);
  $sig2 = $Mvar;
  if ($par_list) { $sig2 .= "(" . $par_list. ")"; }
  my $shortsig = (length($sig2) <= 25);
  $sig1 = &insert_URLs_and_quote($Mname);
  $sig2 = &insert_URLs_and_quote($sig2);
  &opentabular(3);
  if ( $shortsig ) 
  { &print_table_row($sig1,$sig2,$semantics); }
  else {
    &print_table_row($sig1,&multicol(2,$sig2));
    &print_table_row("","",$semantics);
  }
  return;
}

my ($arg1,$arg2,$arg3,$arg4) = ("","","","");
$arg1 = &convert_M($Mname);  
$arg2 = &convert_M($Mvar);
$arg3 = &convert_M($par_list);
$arg4 = &convert_to_LaTeX($semantics);
print_unit("\\create\{$arg1\}\n\{$arg2\}\n\{$arg3}\n\{$arg4\}");
}

#line 2814 "ext.nw"
sub print_destructor {

  my ($mode,$Mname,$semantics) = @_;
  my $sig = "~".$Mname."()";
  if ($mode eq "Fman") {
    print_unit($sig);
    print_unit(&convert_to_ASCII($semantics,5,70));
  }
  elsif ($mode =~ /HTML/) {
    &print_table_row($sig,&convert_to_HTML($semantics));
  }

  my ($arg1,$arg2);
  $arg1 = &convert_M($Mname);
  $arg2 = &convert_to_LaTeX($semantics);
  &print_unit("\\destruct\{$arg1\}\n\{$arg2\}");
}


#line 2840 "ext.nw"
sub print_enum {

  my ($mode,$Mname,$type,$enumconsts,$semantics) = @_;
  my $signature = $Mname . "::" . "$type";
  my @enumvals = split(',',$enumconsts);
  &create_indexentry($mode, $type, "local");
  foreach $enumv (@enumvals) 
  { &create_indexentry($mode, $enumv, "local"); }

if ($mode eq "Fman") {
  &print_unit("$signature \{ ".join(", ",@enumvals)." \}");
  &print_unit(&convert_to_ASCII($semantics,5,70));
  return;
}
if ($mode =~ /HTML/) {
  my $shortsig = (length($signature) <= 25);
  $signature = &insert_URLs_and_quote($signature);
  &opentabular(2);
  $semantics = &convert_to_HTML($semantics);
  if ($shortsig) 
  { &print_table_row($signature, $semantics); }
  else { 
    &print_table_row(&multicol(2,$signature)); 
    &print_table_row("",$semantics);
  }
  return;
}

  # now the latex print:
  $signature = &convert_M($signature);
  $enumconsts = &convert_R($enumconsts);
  $semantics = &convert_to_LaTeX($semantics);
  &print_unit("\\enum\{$signature\}\n\{$enumconsts\}\n\{$semantics\}");
}


#line 2885 "ext.nw"
sub print_typemember 
{
  my ($Mname,$type,$semantics) = @_;
  my $signature = $Mname."::"."$type";
  &create_indexentry($mode, $type, "local");

if ($mode eq "Fman") {
  &print_unit($signature);
  &print_unit(&convert_to_ASCII($semantics,5,70));
  return;
}
if ($mode =~ /HTML/) {
  $semantics = &convert_to_HTML($semantics);
  my $shortsig = ( length($signature) <= 25 );
  $signature = &insert_URLs_and_quote($signature);
  &opentabular(2);
  if ( $shortsig ) 
  { &print_table_row($signature, $semantics); }
  else {
    &print_table_row(&multicol(2,$signature));
    &print_table_row("","",$semantics);
  }
  return;
}

  $signature = &convert_M($signature);
  $semantics = &convert_to_LaTeX($semantics);
  &print_unit("\\typemember\{$signature\}\n\{$semantics\}");
}

#line 2924 "ext.nw"
sub print_event 
{
  my ($scope,$eventname,$par_list,$semantics) = @_;
  my $signature = $scope.$eventname."(".$par_list.")";;
  &create_indexentry($mode, $eventname, "local");

if ($mode eq "Fman") {
  &print_unit($signature);
  &print_unit(&convert_to_ASCII($semantics,5,70));
  return;
}
if ($mode =~ /HTML/) {
  $semantics = &convert_to_HTML($semantics);
  my $shortsig = ( length($signature) <= 25 );
  $signature = &insert_URLs_and_quote($signature);
  &opentabular(2);
  if ( $shortsig ) 
  { &print_table_row($signature, $semantics); }
  else {
    &print_table_row(&multicol(2,$signature));
    &print_table_row("","",$semantics);
  }
  return;
}

  $signature = &convert_M($signature);
  $semantics = &convert_to_LaTeX($semantics);
  &print_unit("\\event\{$signature\}\n\{$semantics\}");
}

#line 3081 "ext.nw"
sub error_handler{
  local($text) =  @_;  # read argument into local variable
  print STDERR "A problem occured near line " , $. ,"\n";
  print STDERR "ERROR: ",$text,"\n\n";
  print STDERR "The current code unit is:\n";
  print STDERR $original_code_unit, "\n";
  print STDERR "The current manual comment is:\n";
  print STDERR $original_comment, "\n\n";
  if ($ack eq "yes") 
  { print STDERR "*  "; read(STDIN,$meaningless,1); }
}

sub print_warning {
  if ($warnings eq "no" || $nextwarning eq "no") { return; }
  local($text) =  @_;  # read argument into local variable
  if ($warnings eq "log")
  { print LOGFILE "WARNING: $text\n"; 
    print LOGFILE "CODEUNIT:\n$original_code_unit\n";
    print LOGFILE "MANCOMMENT:\n$original_comment\n\n";
    return;
  }
  print STDERR "A problem occured near line " , $. ,"\n";
  print STDERR "WARNING: ",$text,"\n\n";
  print STDERR "The current code unit is:\n\n";
  print STDERR $original_code_unit, "\n";
  print STDERR "The current manual comment is:\n\n";
  print STDERR $original_comment, "\n\n";
  if ($ack eq "yes") 
  { print STDERR "*  "; read(STDIN,$meaningless,1); }
}

sub print_info {
  if ($informational eq "yes") {
    local($text) =  @_;  # read argument into local variable
    print STDERR "$text\n\n";
  }
}

sub print_debug {
  if ($debugging eq "yes") {
    local($text) =  @_;  # read argument into local variable
    print STDERR "DEBUG $text\n";
  }
}


#line 3136 "ext.nw"
sub remove_enclosing_blanks
{
  if ($_[0] =~ /^ *$/) { $_[0] = ""; }
  else { 
    $_[0] =~ / *(.*[^ ]) *$/; 
    $_[0] = $1;   
  }
}



#line 3151 "ext.nw"
sub opentabular{
 local($cols) = @_;  # this is either two, three or four
 if ($HTMLopentabular eq "no") {
   if ($cols == 2) {
     print OUTPUT "\\begin{tabular}{ll}\n"; }
   elsif ($cols == 3) {
     print OUTPUT "\\begin{tabular}{lll}\n"; }
   elsif ($cols == 4) {
     print OUTPUT "\\begin{tabular}{llll}\n"; }
   else {
     &error_handler("open_tabulator expects argument 2 or 3"); 
   }
   $HTMLopentabular = "yes";
 }
}

sub closetabular{
 if ($HTMLopentabular eq "yes") {
   print OUTPUT "\\end{tabular}\n\n";
   $HTMLopentabular = "no";
 }
}


#line 3926 "ext.nw"
sub print_usage {
if ($mode eq "Lman" || $mode eq "Ldoc") {
  print "Usage is
          $mode file [options]

Options are given in assignment syntax variable=value. There must be no
blank on either side of the equality sign. We list all variables and 
their possible values below. For each variable the default value of 
each option is given first.

size={12,11,10}
constref={no,yes}
partypes={no,yes}
numbered={no,yes}
xdvi={yes,no}
warnings={yes,no}
includefile={no,yes}
indexing={no,yes}
informational={yes,no}
ack={yes,no}
usesubscripts={no,yes}
latexruns={1,2,0}
delman={yes,no}
filter={all,signatures,definition,types,creation,
operations,implementation,example,opname}

$mode can be customized by putting options in a file 
$mode.cfg in either the home directory or the working 
directory.

Call 
      $mode ltools 
        for more information on the tools usage.
      $mode mancommands 
        for a short overview of usable manual commands.\n\n";
}

if ($mode eq "Fman") {
  print "Usage is
          $mode file filter

where the file name is of the form T.[h|w|lw] and T is either 
the name of a LEDA type, e.g., list, sortseq, or point, or 
the name of a user defined data type. The value of filter is 
one of 

 { all, signatures, definition, types, creation, 
   operations, implementation, example, opname }

Call 
      $mode ltools 
        for more information on the tools usage. 
      $mode mancommands 
        for a short overview of usable manual commands.\n\n" ;
}
exit;
}


sub print_mancommands {
if ($mode eq "Lman" || $mode eq "Ldoc" || $mode eq "Fman") {
print "Manpage start header is:

   /*{\\Manpage {DT} {T1,..,Tk} {short_description} [MVAR]}*/
   afterwards common variables are 
   \\Mname = DT<T1,..,Tk>
   \\Mvar =  MVAR

Manual sections are:

   /*{\\Mdefinition specification_text}*/

   /*{\\Mtypes [W]}*/
       /*{\\Mtypedef typedef_documentation}*/
       /*{\\Mtypemember type_documentation}*/
       /*{\\Menum type_documentation}*/

   /*{\\Mcreation [MVAR] [W]}*/
       /*{\\Mcreate constructor_specification }*/
       /*{\\Mdesctruct desctructor_specification }*/

   /*{\\Moperations [W1] [W2]}*/          
       /*{\\Mop semantic_description }*/ 	
       /*{\\Mstatic semantic_description }*/
       /*{\\Mconversion semantic_description }*/
       /*{\\Mbinop semantic_description }*/
       /*{\\Munop semantic_description }*/
       /*{\\Marrop semantic_description }*/ 
       /*{\\Mfunc semantic_description }*/
       /*{\\Mfunop semantic_description }*/
       /*{\\Mfunobj semantic_description }*/
       /*{\\Mbinopfunc semantic_description }*/
       /*{\\Munopfunc semantic_description }*/ 
       /*{\\Mfunobj{return_type} semantic_description }*/

   /*{\\Mevents [W]}*/
       /*{\\Mevent event_specification }*/

   /*{\\Mimplementation implemenation_information }*/
   /*{\\Mexample example_description }*/

Additional man commands
  /*{\\Mtext some_text }*/
  /*{\\Moptions nextwarning=no }*/
  /*{\\Moptions outfile=new_man_file_name }*/
  /*{\\Msubst pattern replacement }*/
Common tex macros for man comments are 
  \\setopdims[2], \\precond[1], \\headerline[1]
Verbatim code in example section with environment 
  \\begin|end{Mverb}.\n\n"; 
}
exit;
}

sub print_ltools {
$owd = $ENV{"PWD"};
chdir ("/tmp");
local($pid)=$$;
if ($mode eq "Fman") {
  system("cat \$TAMEROOT/Manual/MANUAL/DocTools.tex");
}
else {
  $outfile = "/tmp/" . $pid . "-ext.tex";
  open(OUTPUT,">".$outfile);
  print OUTPUT "\\documentclass\[11pt,a4paper\]\{article\}\n\n"; 
  print OUTPUT "\\usepackage\{html\}";
  print OUTPUT "\\input " . $ENV{"TAMEROOT"} . "/Manual/tex/MANUAL.pagesize\n\n";
  print OUTPUT "\\input " . $ENV{"TAMEROOT"} . "/Manual/tex/MANUAL.mac\n\n"; 
  print OUTPUT "\\begin\{document\}\n\n";
  close(OUTPUT);
  system("cat \$TAMEROOT/Manual/MANUAL/DocTools.tex  >> $outfile");
  open(OUTPUT,">>".$outfile);
  print OUTPUT "\\end\{document\}\n\n";
  close(OUTPUT);
  system ("latex /tmp/$pid-ext.tex $dontshowinfo");
  system ("xdvi /tmp/$pid-ext.dvi $dontshowinfo");
  system ("rm -f /tmp/$pid-ext.*");
}
chdir ("$owd");
exit;
}



