/****************************************************************************
+       TAME 1.0
+
+       bassign.h
 ****************************************************************************/

#ifndef TAME_BASSIGN_H
#define TAME_BASSIGN_H

#include <deque.h>
#include "./var.h"
#include <pair.h>

/*{\Manpage {bassign} {} {Assegnazioni Base di Variabili} {BA}*/

struct bassign  {
/*{\Mdefinition 
Una istanza del tipo di dati |\Mname| rappresenta una assegnazione di letterali 
a valori costanti.
}*/

  bool toggle;
  var lhs; // assign left hand side
  var rhs; // assign right hand side

/***** Service Utility Functions *****/

/***** End Service Utility Functions *****/

public:
/*{\Mcreation BA }*/

  bassign (const var & a, const var & b, bool tgl=false){
    if (a.is_negative()) {
      lhs = not (a);
      rhs = not (b);
    }
    else {
      lhs = a;
      rhs = b;
    }  
    toggle = tgl;
  }

  bassign (const bassign & bb) {
/*{\Mcreate Costruttore di copia}*/
    lhs = bb.lhs;
    rhs = bb.rhs;
    toggle = bb.toggle;
  }

/*{\Moperations 1.8 5}*/

  void
  set_label () {toggle = true;}
/*{\Mop Setta il flag di backtrack.}*/

  void
  unset_label () {toggle = false;}
/*{\Mop Resetta il flag di backtrack.}*/  
  
  bool
  label () {
/*{\Mop Restituisce se la assegnazione \'e di backtrack oppure no.}*/
    if (toggle)
      return true;
    return false;  
  }

  bassign &
  inverse () {
/*{\Mfunc Restituisce la assegnazione cambiata di segno.}*/
    rhs = not (rhs);
    return *this;
  }  
    
  bassign &
  operator = (const bassign bb) {
/*{\Mbinop Assegnazione.}*/
    lhs = bb.lhs;
    rhs = bb.rhs;
    toggle = bb.toggle;
    return *this;
  }
  
  friend
  ostream &
  operator << (ostream & os, const bassign & BA) {
/*{\Mbinopfunc Stampa su |os| il contenuto di |\Mvar|, nel formato: \\
|<var1>| -> |<const_value1>| \\
}*/
    os <<  BA.lhs << "<-" << BA.rhs << " " << BA.toggle;
    return os;
  }   
};

#endif //TAME_BASSIGN_H
