/*****************************************************************************
+	TAME 1.0
+
+	occurrence.h
 *****************************************************************************/
class occurrence {
  private:
    unsigned short int _cpos;
    unsigned short int _cneg;
    unsigned short int _xor;
    unsigned short int _sel;
    unsigned short int _ass;
  public:
    occurrence () {
      _cpos = 0;
      _cneg = 0;
      _xor = 0;
      _sel = 0;
      _ass = 0;
    }

    occurrence (int orpos, int orneg, int xor, int sel, int ass) {
      _cpos = (unsigned short int) orpos;
      _cneg = (unsigned short int) orneg;
      _xor = (unsigned short int) xor;
      _sel = (unsigned short int) sel;
      _ass = (unsigned short int) ass;
    }

    int
    get_cpos () const {return (int) _cpos;}

    int
    get_cneg () const {return (int) _cneg;}

    int
    get_xor () const {return (int) _xor;}

    int
    get_sel () const {return (int) _sel;}

    int
    get_ass () const {return (int) _ass;}

    void
    incr_cpos () {_cpos ++;}

    void
    incr_cneg () {_cneg ++;}

    void
    incr_xor () {_xor ++;}

    void
    incr_sel () {_sel ++;}
    
    void
    incr_ass () {_ass ++;}

    void
    decr_cpos () {if (_cpos > 0) _cpos --;}

    void
    decr_cneg () {if (_cneg > 0) _cneg --;}

    void
    decr_xor () {if (_xor > 0) _xor --;}

    void
    decr_sel () {if (_sel > 0) _sel --;}

    void
    decr_ass () {if (_ass > 0) _ass --;}

    void
    set_cpos (int i) {_cpos = i;}

    void
    set_cneg (int i) {_cneg = i;}

    void
    set_xor (int i) {_xor = i;}

    void
    set_sel (int i) {_sel = i;}

    void 
    set_ass (int i) {_ass = i;}

    void
    reset_occurrences () {
      _cpos = 0;
      _cneg = 0;
      _xor = 0;
      _sel = 0;
      _ass = 0;
    }

    int
    get_abs_occurrences () const {return (int) (_cpos + _cneg + _xor);}

    int
    get_split_occurrences () const {return (int) (_cpos + _cneg + _xor + _sel);}

    bool
    operator == (const occurrence & P) const {
      if ( (_cpos == P._cpos) &&
           (_cneg == P._cneg) &&
	   (_xor == P._xor) &&
	   (_sel == P._sel) &&
	   (_ass == P._ass) )
	return true;
      return false;
    }  

    occurrence &
    operator = (const occurrence & P) {
      _cpos = P._cpos;
      _cneg = P._cneg;
      _xor = P._xor;
      _sel = P._sel;
      _ass = P._ass;
      return (*this);
    }  
    
    occurrence &
    operator += (const occurrence & P) {
      _cpos += P._cpos;
      _cneg += P._cneg;
      _xor += P._xor;
      return (*this);
    }  
};

