/*****************************************************************************
+	TAME 1.0
+
+	tame.h
 *****************************************************************************/

#ifndef TAME_H
#define TAME_H
#define TAME_VERSION "1.0"
#include <iostream.h>
#include <fstream.h>
#include <time.h>
#include <string.h>
#include "./formula.h"

void
print_version () {
  cout << "tame Version " << TAME_VERSION << " by Paolo Ottolino,";
  cout << " pottol@tiscalinet.it. Based on the work:\n";
  cout << " \"The Taming of the (X)OR\" ";
  cout << "of Fabio Massacci and Peter Baumgartner\n";
  cout << "Try `tame -h' for more information." << endl;
}

void
print_usage () {
  cout << "Usage: tame [options]\n";
  cout << "Usage: tame -I <input-file> -O <output-file> [options]\n";
  cout << "Options:\n";
  cout << "    -I <input>  \t: specify the input file (default stdin)\n";
  cout << "    -O <output> \t: specify the output file\n";
  cout << "    -S <store>  \t: specify the file to store the status vector\n";
  cout << "    -V          \t: print the version number\n";
  cout << "    -a          \t: all solutions (default only the first)\n";
  cout << "    -b          \t: not use lookahead during normal computation\n";
  cout << "    -c          \t: not use lookahead during initial computation\n";
  cout << "    -e <heur>   \t: run specific heuristic (see the manpage)\n";
  cout << "    -g          \t: disable the Gauss Reduction\n";
  cout << "    -h          \t: this help message\n";
  cout << "    -l          \t: double level lookahead\n";
  cout << "    -s <name>   \t: split only on var whose name is 'char'\n";
  cout << "    -x <number> \t: set verbosity from 0 to 9 (default 0)\n";
  return;
}

void
print_time (ostream & os) {
   char timebuffer[100];
   time_t curtime;
   struct tm *loctime;
   struct tm loctime_buffer;
   curtime = time(NULL);
   loctime = localtime_r(&curtime, &loctime_buffer);
   strftime(timebuffer, 100, "%d/%m/%Y %H:%M:%S", loctime);
   os << timebuffer << endl;
}

void
PrintStartTime (ofstream & of) {
  of << "Starting Computation Time ";
  print_time (of);
}

void
PrintStopTime (ofstream & of) {
  of << "Stopping Computation Time ";
  print_time (of);
}

char
set_heuristics (char * argument) {
  return 'a';
}  

void
PrintSolution (const formula & tide, ostream & outputfile);

void
PrintInsolution (const formula & tide, ostream & outputfile);

#endif // TAME_H
