/*****************************************************************************
+	TAME 1.0
+
+	utils.h
 *****************************************************************************/

#ifndef TAME_UTILS_H
#define TAME_UTILS_H

#include "./formula.h"


/*{\Manpage {Utilities for Rules} {F} {Utility}  }*/

void
swapvar (var & A, var & B) {
  var C = A;
  A = B;
  B = C;
}  

void
putty_xor (const xorclause x, var & A, var & B) {
/*{\Mfunc assegna le variabili |a| e |b| con gli elementi di |x|.
\precond 	$0 < x.size() < 3$;
                la clausola deve essere stata precedentemente ridotta
                (ovvero: $\bot, \top \not \in x$ e  
		 $\forall c, d \in x, c \not = d$)
Quindi |x| pu\'o contenere solo variabili non costanti e diverse.
}*/		
  unsigned short Size;
  Size = x.size();
  xorclause::const_iterator itx = x.begin();
  if ( Size == 1) {
    if ( (*itx).is_negative()) {
      A = not (*itx);
      B = FALSE;
    }  
    else {
      A = (*itx);
      B = TRUE;
    }  
  }
  if ( Size == 2) {
    if ( (*itx).is_negative()) {
      A = not (*itx);
      itx ++;
      B = (*itx);
    }
    else { // !(*itx).is_negative() 
      A = (*itx);
      itx ++;
      B = not (*itx);
    }
//    if (A.is_costant())
  //    swapvar (A, B);
  }
  return;
}  
#endif // TAME_UTILS_H
