/*****************************************************************************
+	TAME 1.0
+
+	parser.h 	Parser File
 *****************************************************************************/

%header{
#include <iostream>
using namespace std;
#include <FlexLexer.h>
#include "../include/formula.h"
#include "../include/varset.h"
extern 
yyFlexLexer lexer;

extern
void
AddXor (xorclauset & x, varset & c);

extern
void
AddOr_fromOr (orclauset & C, var a, varset & V);

extern
void
AddOr_fromAnd (orclauset & C, var a, varset & V);

%}

%{
var a, b, prop1, prop2, prop3, prop4;
varset c;
%}

%name  Parser
%union
{
    int numero;
    char nome;
    var * puntvar;
    xorclause * puntxor;
    varset * puntset;
};
%define PARSE_PARAM formula & F
%define DEBUG 1

%token Not
%token True
%token False
%token Xor
%token Or
%token And
%token  <numero> NUM
%token  <nome> NAME
%type <puntvar> atom lit head
%type <puntset> litlist xorcl orcl andcl 

%define LEX_BODY {return lexer.yylex();}

%define ERROR_BODY { cerr << "error encountered\n"; }

%%
input:
        | input line
;

line:     '\n'
        | xorcl  {AddXor (F.X, (*$1));}
	| orcl   {AddOr_fromOr (F.C, prop1, (*$1));}
	| andcl  {AddOr_fromAnd (F.C, prop2, (*$1));}
;

andcl:
          head And {c.clear(); prop2 = (*$1);}
          '(' litlist ')' '\n' {$$ = $5;}
;

xorcl:	  head Xor {c.clear(); c.add (not (*$1));}
	  '(' litlist ')' '\n' {$$ = $5;}
;

orcl:
	  head Or {c.clear(); prop1 = (*$1);}
	  '(' litlist ')' '\n' {$$ = $5;}
;	  

litlist:  lit             {c.add ( *$1); $$ = &c;}
        | litlist ';' lit { (*$1).add (*$3); $$ = $1;}
;

head:	  lit '='	{$$ = $1;}
;

lit:      atom {b = $1;}
	| Not '(' atom ')' {b = not (*$3); $$ = &b;}
;

atom:	  NAME NUM ',' NUM ',' NUM {a = var(true, $1, $2, $4, $6); $$ = & a;}
        | True {a = TRUE; $$ = &a;}
	| False {a = FALSE; $$ = &a;}
;

%%
