/*****************************************************************************
+	TAME 1.0
+
+	populate.C
 *****************************************************************************/


#include "../include/xorclauset.h"
#include "../include/orclauset.h"
#include "../include/varset.h"

static
inline
void 
Add_first_Clause_fromOr (orclauset & C, var a, varset & V) {
  orclause temp;
  varset::iterator itv;
  temp.add ( not (a) );
  for (itv = V.begin(); itv != V.end(); itv++)
    temp.add (*itv);
  C.add (temp);
  return;
}

static
inline
void
Add_binary_Clauses_fromOr (orclauset & C, var a, varset & V) {
  orclause temp;
  varset::iterator itv;
  temp.add (a);
  for (itv = V.begin(); itv != V.end(); itv ++) {
    temp.add (not (*itv));
    C.add (temp);
    temp.erase ( not(*itv) );
  }
  return;
}

static
inline
void
Add_first_Clause_fromAnd(orclauset & C, var a, varset & V) {
  orclause temp;
  varset::iterator itv;
  temp.add (a);
  for (itv = V.begin(); itv != V.end(); itv ++)
    temp.add ( not (*itv) );
  C.add (temp);
  return;
}

static
inline
void
Add_binary_Clauses_fromAnd (orclauset & C, var a, varset & V) {
  orclause temp;
  varset::iterator itv;
  temp.add ( not (a) );
  for (itv = V.begin(); itv != V.end(); itv ++) {
    temp.add (*itv);
    C.add (temp);
    temp.erase (*itv);
  }
  return;
}

void
AddXor (xorclauset & x, varset & c) {
  xorclause xtmp;
  for (varset::const_iterator itc = c.begin();
       itc != c.end();
       itc ++)
    xtmp.add ( (*itc) );
  x.add (xtmp);
  return;
}

void
AddOr_fromOr (orclauset & C, var a, varset & V) {
  Add_first_Clause_fromOr (C, a, V);
  Add_binary_Clauses_fromOr (C, a , V);
  return;
}

void
AddOr_fromAnd (orclauset & C, var a, varset & V) {
  Add_first_Clause_fromAnd (C, a, V);
  Add_binary_Clauses_fromAnd (C, a, V);
  return;
}

