/*****************************************************************************
+	TAME 1.0
+
+	vbparser.y parser for the stored status file
 *****************************************************************************/

%header{
#include <iostream>
using namespace std;
#include <FlexLexer.h>
#include "../include/lassign.h"

extern
yyFlexLexer vblexer;
%}

%{
var A, B;
%}

%name VBParser
%union
{
    int numero;
    char nome;
    bool label;
    var * puntvar;
};
%define PARSE_PARAM lassign & VB
%define DEBUG 1

%token Not
%token True
%token False
%token  <numero> NUM
%token  <nome> NAME
%token <label> LABEL
%type <puntvar> atom lit head

%define LEX_BODY {return vblexer.yylex();}

%define ERROR_BODY { cerr << "error encountered\n"; }

%%
input:
	  | input line
;
line:	  '\n'
	  | head lit ' ' LABEL {VB.add (*$1, *$2, $4);}
;

head:     lit '<' '-'  {$$ = $1;}
;

lit:      atom {B = $1;}
        | Not '(' atom ')' {B = not (*$3); $$ = &B;}
;

atom:     NAME NUM ',' NUM ',' NUM {A = var(true, $1, $2, $4, $6); $$ = & A;}
        | True {A = TRUE; $$ = &A;}
        | False {A = FALSE; $$ = &A;}
;

%%

