/*****************************************************************************
+	TAME 1.0
+
+	calculate.C
 *****************************************************************************/

#include <fstream.h>
#include <iostream.h>
#include "../include/rules.h"
#include "../include/logger.h"

extern
bool NO_GAUSS;

extern 
tlogger logger;

bool
calculate (formula& F) {
  int iteration = 0; //count actual iteration
  int oreqv = 0; // assignment from OR counter
  int xoreqv = 0; // assignment from XOR counter
  int or3xor = 0; // (3 letter) orclause -> xorclause counter
  xorque XQ; // new found assign (temporaly ordered) queue
  logger (3, "Beginning Calculate");
  
  do { // begin the cycle of calculation
    F.unset_changed(); //reset the changed status
    iteration ++; //set iteraction number
    logger (4, "Calculate Iteration: ", iteration);
    F.set_calculate (iteration); // save iteraction number in F


    do { // cycle of Simplification Eqv -> Simp -> Red -> Unit -> Simp
      F.unset_changed (); // reset the change flag on F
      logger (5, "Calculating the EqvOR...");
      oreqv = EqvOr (F, XQ); // move the candidate assegnments from OR in XQ
      logger (5, "Equivalence = ", oreqv);
      logger (5, "Calculating the EqvXOR...");
      xoreqv = EqvXor (F, XQ); // move the candidate assegnments from XOR in XQ
      logger (5, "Equivalence = ", xoreqv);
      logger (5, "Beginning Simplification from Eqv");
      logger (8, "On the xorque", XQ);
      Simp (F, XQ); // Simp, Red, Unit and set changement flag of F
      logger (5, "End Simplification from Eqv");
      if (F.bottom() || XQ.bottom() ) {
        logger (3, "Bottom arises");
	return false;
      }	
    } while (F.changed());  

  if (!NO_GAUSS) {
    logger (5, "Processing Or -> Xor");
    or3xor = Or3Xor(F); // move the 3-literal OR clause, possibly, to XOR
    logger (5, "New Xorclauses from OR", or3xor);
  } // endif (!NO_GAUSS)

  if (!NO_GAUSS) {
    var a;
    logger (5, "Begin cycle of Gauss Triangulation");
    do {
      a = Select (F);
      logger (5, "Selected the var: ", a);
      if ( a != FALSE) { // it was a good selection
        logger (6, "Beginning the Gauss Reduction");
	Gauss (F, a, XQ);
	F.set_changed(); // set the change flag
        logger (5, "Beginning the Simplification from Gauss");
        logger (8, "On the xorque: ", XQ);
        Simp(F, XQ); // Simp, Red, Unit and set changement flag of F
        logger (5, "End Simplification from Gauss");
      } // end if (good selection)
    } while (a != FALSE); // while good selection
  
  } // endif (!NO_GAUSS)
  
    if (F.bottom() || XQ.bottom() ) {
      logger (2, "Bottom arises");
      return false;
    logger (9, "Formula after calculation:", F);  
    }
  } while (F.changed()); // end cycle of calculation on F    

  logger (3, "Exiting from the Calculate Function");
  return true;
}
