/*****************************************************************************
+       TAME 1.0
+
+       compute.C
 *****************************************************************************/

#include <fstream.h>
#include <iostream.h>
#include "../include/restart.h"
#include "../include/logger.h"

extern 
tlogger logger;

extern
bool COMPUTE_WITH_LOOKAHEAD;

extern
bool INIT_WITH_LOOKAHEAD;

bool
computeone (formula & F, lassign & VB) {
  bool error; //flag of error encountered during computation 
  error = !calculate (F);
  if (error) {
    logger (2, "Compute: Calculate generates bottom");
    return false; // contraddiction during lookahead
  }
  VB.AddCostantAssignment (F.Ass);
  VB.set_min_level (VB.size());
  if (INIT_WITH_LOOKAHEAD) {
    error = !lookahead(F, VB); 
    if (error) {
      logger (2, "Compute: Lookahead generates bottom");
      return false; // contraddiction during lookahead
    }  
    VB.AddCostantAssignment (F.Ass);
    VB.set_min_level (VB.size());
  }  
    return true;
}

bool
compute (formula & F, lassign & VB) {
  bool error; //flag of error encountered during computation
  error = !calculate (F);
  if (error) {
    logger (2, "Compute: Calculate generates bottom");
    return false; // contraddiction during lookahead
  }

  if (COMPUTE_WITH_LOOKAHEAD) {
    error = !lookahead(F, VB);
    if (error) {
     logger (2, "Compute: Lookahead generates bottom");
     return false; // contraddiction during lookahead
    }
  }  //COMPUTE_WITH_LOOKAHEAD  
  return true;
}

