/*****************************************************************************
+	TAME 1.0
+
+	heuristics.C	Strategy Functions
 ****************************************************************************/

#include "../include/formula.h"

  float
  power2 (int i) {
    float power = 2;
    for (; i > 0; i--)
      power *= 2;
    return power;  
  }


  float
  MaximumXorClauseLenght (const formula & F) {
    float max_size = 0;
    float curr_size;
    xorclauset::const_iterator itx;
    for (itx = F.X.begin(); itx != F.X.end(); itx ++) {
      curr_size = (float) (*itx).size();
      if (curr_size > max_size)
        max_size = curr_size;
    }
    return max_size;
  }

  float
  MediumOrClauseLenght (const formula & F) {
    float average = 0;
    orclauset::const_iterator itc;
    for (itc = F.C.begin(); itc != F.C.end(); itc ++) {
      average += (float) ( (float) (*itc).size() / (float) F.C.size());
    }
    return average;
  }
  
  float
  MediumXorClauseLenght (const formula & F) {
   float average = 0;
   xorclauset::const_iterator itx;
   for (itx = F.X.begin(); itx != F.X.end(); itx ++) {
     average += (float) ( (float) (*itx).size() / (float) F.X.size());
   }
   return average;
  }

  float
  MediumSelectedXorLenght (const formula & F) {
    float average = 0;
    selectxor::const_iterator its;
    for (its = F.S.begin(); its != F.S.end(); its ++) {
      average += (float) ( (float) (*its).second.size() / (float) F.S.size());
    }
    return average;
  }
  
  float
  MaximumSizeofAssSet (const formula & F) {return F.Ass.size();}

  float
  MinimumMediumOrClauseLenght (const formula & F) {
    float clause_number = (float) F.C.size();
    float score = 0;
    orclauset::const_iterator itc;
    for (itc = F.C.begin(); itc != F.C.end(); itc ++) {
      score += ((*itc).size() / (clause_number));
    }
    return (- score);
  }

  float
  MaximalMediumOccorrenceinXor (const formula & F) {
    float score = 0;
    float open_lits = (float) (F.V.size() - F.Ass.size());
    vset::const_iterator itv;
    for (itv = F.V.begin(); itv != F.V.end(); itv ++) {
      score += (float) ((*itv).second.get_xor() / open_lits);
    }
    return score;
  }

  float
  MinimumXorClausesMediumDimension (const formula & F) {
    float score = 0;
    float open_lits = (float) (F.V.size() - F.Ass.size());
    float max_xor_size = MaximumXorClauseLenght (F);
    float specific_size = open_lits / max_xor_size;
    xorclauset::const_iterator itx;
    for (itx = F.X.begin(); itx != F.X.end(); itx ++) {
      score += ( (*itx).size() * (*itx).size() /  specific_size);
    }
    return (- score);
  }

  float
  MaximalAddedConstraints (const formula & F) {
    float score = 0;
    int or_med_len = (int) MediumOrClauseLenght (F);
    int xor_med_len = (int) MediumXorClauseLenght (F);
    int sel_med_len = (int) MediumSelectedXorLenght (F);
    score += (float) (F.Ass.size() * power2 (or_med_len));
    score += (float) (F.X.size() * power2 (or_med_len - xor_med_len + 1));
    score += (float) (F.S.size() * power2 (or_med_len - sel_med_len + 1));
    score += (float) (F.C.size());
    return score;
  }

