/****************************************************************************
+	TAME 1.0
+
+	init.C 
+	initialization of the formulas, with parser and building of the 
+	set of the occurent propositions
 ****************************************************************************/

#include <FlexLexer.h>
#include <iostream.h>
#include <fstream.h>
#include <stdio.h>
#include <string.h>
#include <algo.h>
#include "../parser/parser.h"
#include "../include/formula.h"
#include "../include/xorque.h"
#include "../include/logger.h"

extern
tlogger logger;

extern
bool
RedUnit (formula & F, xorque & XQ);

extern
bool
Simp (formula & F, xorque & XQ);

Parser parser;
yyFlexLexer lexer;

int 
init (formula & F, char * infile) {
/*** begin initialization of the clauses ***/
  ifstream inputfile;
  if (strcmp ("",infile) ) { // if it was specified a input file
    inputfile.open (infile, ios::in);
    if (!inputfile.is_open() ) {
      logger (0, "Can't Open input file");
      return 0;
    }  
    else
      logger (1, "Input file open, setting the scanner");
    lexer.yyrestart (& inputfile);
  } // end if it was specified a input file
  logger (4, "Beginning the parsing...");
  parser.yyparse(F);
  logger (4, "Parsing done");
  if (inputfile.is_open() ) inputfile.close(); // close the file
/*** end initialization of the clauses ***/  

/*** initialization of the vset ***/
  xorque XQ; // xorque for the initial reduction and unit finding
  logger (4, "Beginning Reduction");
  RedUnit (F, XQ);
  logger (4, "Beginning Simplification");
  Simp (F, XQ); 
  if (F.bottom() || XQ.bottom())
    return 0;
  logger (4, "Resyncing Occurrences...");
  F.resync_vset ();
  logger (4, "Resyncing maden");
  return 1;
}

