/*****************************************************************************
+	TAME 1.0
+
+	restart.C
 *****************************************************************************/

#include "../include/restart.h"
#include "../include/rules.h"
#include "../include/logger.h"
#include "../include/storer.h"

extern
tlogger logger;

extern
tstorer storer;

extern
ofstream outputfile;

extern
bool ALL_SOLUTIONS;

bool
restart (formula & F, const formula & G, lassign & VB) {
  var a; // the auxiliary var for the result of the splitting
  xorque XQ; // the queue of the assignment for the formula
  int cycle = 0; // cycle counter
  do {
    cycle ++;
    F.set_restart (cycle);
    logger (1, "Beginning Restart iteration", cycle);
    storer (VB); // store the status in statusfile
    if (F.bottom()) {
      logger (4, "Bottom arised: reordering VB");
      VB.Reorder ();
      if (!VB.empty()) {
        logger (4, "!VB.empty(), storing");
        logger (4, "Assigning tide with reference");
	F = G;
	logger (4, "AddAllArbitraryAssign");
	XQ.clear();
	XQ.AddAllArbitraryAssignment (VB);
	logger (6, "On xorque XQ", XQ);
	logger (4, "Simplifing tide");
	Simp (F, XQ);
	if (!F.bottom()) {
	  logger (4, "Computing tide");
	  compute (F, VB);
	}  
      }	// endif (!VB.empty())
      else
        break;
    } // endif (F.bottom())
    
    else { // !F.bottom()
      logger (4, "!Bottom: proceding with Split");
      logger (4, "The Assigned Vars are:", VB);
      a = Split (F, VB);
      logger (4, "Restart: Choosed the var ", a);
      if (a == FALSE) { // there was no var to split
        logger (4, "Split insuccessfull: printing solution");
	F.PrintSolution (outputfile);
	if (ALL_SOLUTIONS) // you want all solutions, so...
	  F.C.set_bottom(); // ...force the restart!
	else // it's the case you have others things to do...
	  return true; // exit
      } // endif ( a== FALSE) => Not Proficous Split
      
      else { // Split was positive
        logger (4, "Successfull Split: AddArbitrary Assign");
	VB.add (a);
	logger (6, " Passing the VB Set", VB);
	XQ.clear();
	XQ.Add (a, TRUE);
	logger (4, "On xorque ", XQ);
	logger (4, "Simplifiing tide");
        Simp (F, XQ);
        if (!F.bottom()) { 
	  logger (4, "Computing tide");
	  compute (F, VB);
	}  
      } 
    } // end !F.bottom()
  } while (!VB.empty());
  logger (4, "VB empty: insolution");
  F.PrintInsolution (outputfile);
  logger (4, "Exiting from Restart");
  return false;
}  
