/*****************************************************************************
+	TAME 1.0
+
+	gauss.C
 *****************************************************************************/

#include "../../include/rules.h"

static
void
calc_resolvent (xorclause & x, const xorclause s) {
  for (xorclause::iterator itdef = s.begin();
       itdef != s.end();
       itdef ++) 
    x.add ( (*itdef) );   
}

int
Gauss (formula & F, var A, xorque & XQ) {
  int resolved = 0;
  xorclause temp;
  xorclause::iterator itcl;
  xorclause resolving = F.S[A];
  for (xorclauset::iterator itx = F.X.begin();
       itx != F.X.end();) { // for all xorclause in F.X
    temp = (*itx); // copy current clause in temp   
    if ( (itcl = temp.find (A)) != temp.end() ) { // Gauss +
      temp.erase (itcl); // delete A from the copy of current clause
      calc_resolvent (temp, resolving);
      RedXor (temp);
      if (!UnitXor (temp, XQ)) { // if it wasn't a valid unit clause
        if (XQ.bottom() ) { // it generated a contraddiction -> set bottom
	  return 0;
	}
        else { // !Unit && !XQ.bottom()	
          F.DelXor (itx++); // delete the old clause
          F.AddXor ( (temp) ); // insert the resolvent (gauss+)
        }
      }  
      else // Unit (new xorclause in XQ)
        F.DelXor (itx ++); // so eliminate the xorclause
      resolved ++;
      continue;
    } // end if (find (A) in current clause)  
    if ( (itcl = temp.find (not(A) )) != temp.end() ) { // Gauss -
      temp.erase (itcl); // delete A from the copy of current clause
      calc_resolvent (temp, not (resolving));
      RedXor (temp);
      if (!UnitXor (temp, XQ)) { // if it wasn't a valid unit clause
        if (XQ.bottom() ) { // it generated a contraddiction -> set bottom
          return 0;
        }
        else { // !Unit && !XQ.bottom()
          F.DelXor (itx++); // delete the old clause
          F.AddXor ( (temp) ); // insert the resolvent (gauss+)
        }
      }
      else // Unit (new xorclause in XQ)
        F.DelXor (itx ++); // so eliminate the xorclause
      resolved ++;
      continue;
    } // end if (find ( (A) ) in current clause)	 
    else // not (exists A or not(A) in current clause)
      itx ++;
  } // end for all xorclause in F.X
  
  for (selectxor::iterator its = F.S.begin();
       its != F.S.end();) { // for all definition in F.S
    temp = (*its).second; // copy current definition in temp
    if ( (itcl = temp.find (A)) != temp.end() ) { //Gauss +
      temp.erase (itcl); //delete A from the copy of current definition
      calc_resolvent (temp, resolving);
      RedXor (temp);
      if (temp.size() == 1) { // if it was a valid unit clause
        xorclause::iterator itx = temp.begin();
	XQ.Add ((*its).first, (*itx)); // insert the new assignment
	F.DelSel (its ++);
      }
      else if (temp.size() == 0) { // it was a bottom clause
        XQ.Add ((*its).first, FALSE); // insert the new assignment
	F.DelSel (its ++);
      }
      else if (temp.size() > 1) { // it wasn't a unit clause
	var aux = (*its).first;
	temp.add (not (aux));
	F.DelSel (its ++); // so eliminate the definition
	F.AddSel (aux, temp);
      }	
      resolved ++;
      continue;
    }// end if (find ( (A) ) in current definition)
    else if ( (itcl = temp.find (not(A) )) != temp.end() ) { //Gauss -
      temp.erase (itcl); //delete A from the copy of current definition
      calc_resolvent (temp, not (resolving));
      RedXor (temp);
      if (temp.size() == 1) { // if it was a valid unit clause
        xorclause::iterator itx = temp.begin();
        XQ.Add ((*its).first, (*itx)); // insert the new assignment
        F.DelSel (its ++);
      }
      else if (temp.size() == 0) { // it was a bottom clause
        XQ.Add ((*its).first, FALSE); // insert the new assignment
        F.DelSel (its ++);
      }
      else if (temp.size() > 1) { // it wasn't a unit clause
        var aux = (*its).first;
        temp.add (not (aux));
        F.DelSel (its ++); // so eliminate the definition
        F.AddSel (aux, temp);
      }
      resolved ++;
      continue;
    } //end if (find (not(A) ) ) in current definition  
    else its ++;
  } // end for all definition in F.S   
  return resolved;   
}
