/*****************************************************************************
+	TAME 1.0
+
+	or3xor.c
 *****************************************************************************/

#include "../../include/rules.h"

inline
static
void
putty (const orclause & c, var & A, var & B, var & C) {
  orclause::iterator itcl = c.begin();
  A = (*itcl ++);
  B = (*itcl ++);
  C = (*itcl);
  return;
}

inline
static
orclause
or (var a, var b, var c) {
  orclause temp;
  temp.add (a);
  temp.add (b);
  temp.add (c);
  return temp;
}

inline
static
xorclause
xor (var a, var b , var c) {
  xorclause temp;
  temp.add (a);
  temp.add (b);
  temp.add (c);
  return temp;
}

int
Or3Xor (formula & F) {
  var A, B, C;
  int moved = 0;
  orclauset::iterator compl1, compl2, compl3;
   for (orclauset::iterator it1 = F.C.begin();
       it1 != F.C.end();) { // for all clause in F.C
     if ( (*it1).size() == 3 ) { // if the size == 3
       putty ( (*it1), A, B, C); // put the var of the current clause in A,B,C
       compl1 = F.C.find (or (A, not(B), not(C) )) ;
       compl2 = F.C.find (or (not(A), B, not(C) )) ;
       compl3 = F.C.find (or (not(A), not(B), C )) ;
     if ( (compl1 != F.C.end() )&&
          (compl2 != F.C.end() )&&
	  (compl3 != F.C.end()) ) {
    // if were found the three complement of the current clause	 
         F.AddXor ( xor(A, B, C)); // insert the new xor
	      moved ++;
         F.DelOr (compl1); // erase the three complement...
         F.DelOr (compl2);
         F.DelOr (compl3);
         F.DelOr (it1 ++); // ... and erase the current clause
       } // end if (compl1 compl2 compl3)
       else // there isn't all the three complement
         it1 ++; // go on
     } // end if size == 3	
     else // the size != 3
       it1++; //go on
    } //end for all clause in F.C    
  return moved;    
}
