/*****************************************************************************
+	TAME 1.0
+
+	redOr.C
 *****************************************************************************/

#include "../../include/rules.h"

inline
static
bool
firstRed (orclause & c) {
/* first. eliminate TRUE costant: T V C -> C if C != {} */
  orclause::iterator it;
  it = c.find (TRUE);
  if ( (it != c.end() ) && (c.size() > 1) ) {
    c.clear (); // erase all
    c.add (TRUE); //reinsert only TRUE
    return true;
  }// end if
  else return false;
}

inline
static
bool
secondRed (orclause & c) {
/* second. eliminate FALSE costant: F V C -> C also if C == {} */
  orclause::iterator it;
  it = c.find (FALSE);
  if ( it!= c.end() ) {
    c.erase (it);
    return true;
  }
  else return false;
}

#ifdef WE_DONT_USE_THE_SETS_FOR_ORCLAUSE
static
bool
thirdRed (orclause & c) {
  // third. eliminate same-sign redundancies: L V L V C -> L V C 
  orclause::iterator it;
  int occurrence;
  for (it = c.begin(); // for all var in c
       it != c.end();) {
    for (occurrence = c.count ( *it); // count the occurence of current var
         occurrence <= 1; // almost 1 must stay
         occurrence --) { // decrement the occurrence
      c.erase ( *it);
      reduce = true;
    }
    it ++;
  }
}
#endif //WE_DONT_USE_THE_SETS_FOR_ORCLAUSE

inline
static
bool
fourthRed (orclause & c) {
  /* fourth. eliminate toggle-sign redundancies: L V -L V C -> T */
  orclause::iterator it;
  var A;
  for (it = c.begin ();
       it != c.end();) {
    A = (*it);
    if (c.find (not (A)) != c.end () ) {
      c.clear (); //erase all element
      c.add (TRUE); //reinsert only TRUE
      return true;
    }  // end if
    else it ++;
  } //end for (it)
  return false;
}

bool
RedOr (orclause & c) {
  int rednumber;
  rednumber = 0; //reset the reduce-iteration conter
  do {
    rednumber ++; // set counter
  } while ( firstRed (c) ||
            secondRed (c) ||
            fourthRed (c) ); // until reduce the clause
  if (rednumber > 1) //it was a profit reduction
    return true;
  return false;
}
