/*****************************************************************************
+	TAME 1.0
+
+	redunit.C
 *****************************************************************************/

#include "../../include/rules.h"

void
putty_xor (const xorclause & x, var & a) {
  xorclause::const_iterator itx = x.begin();
  a = (*itx);
}  

int
RedUnit (formula & F, xorque & XQ) {
  int reductions = 0; // reduction maden counter
  orclause ortemp; // comodity orclause
  xorclause xortemp; // comodity xorclause
  xorclause seltemp; // comodity xor selection

  for (orclauset::iterator itc = F.C.begin();
      itc != F.C.end();) { //for all clause in F.C
    ortemp = (*itc); //assign the temp clause with current clause
    if (RedOr (ortemp)) {
      if (!UnitOr (ortemp, XQ)) { // if wasn't a valid unit clause
        if (XQ.bottom() ) { // there is a contraddiction
          F.C.set_bottom ();
          return 0; // exit immediately
        }
        else { // !Unit && !XQ.bottom()
          F.DelOr (itc ++); //eliminate the old...
          F.AddOr (ortemp); //... and add the new (simplified)
        }
      } // end if (!Unit)
      else // Unit (new xorclause in XQ)
        F.DelOr (itc ++); // so eliminate the orclause
      reductions ++;
    }
    else // !RedOr (ortemp): skip over
      itc ++;
  } // end for (it1)

  for (xorclauset::iterator itx = F.X.begin();
      itx != F.X.end();) { //for all clause in F.C
    xortemp = (*itx); //assign the temp clause with current clause
    if (RedXor (xortemp)) {
      if (!UnitXor (xortemp, XQ)) { // if wasn't a valid unit clause
        if (XQ.bottom() ) { // there is a contraddiction
          F.C.set_bottom ();
          return 0; // exit immediately
        }
        else { // !Unit && !XQ.bottom()
          F.DelXor (itx ++); //eliminate the old...
          F.AddXor (xortemp); //... and add the new (simplified)
        }
      } // end if (!Unit)
      else // Unit (new xorclause in XQ)
        F.DelXor (itx ++); // so eliminate the orclause
      reductions ++;
    }
    else itx ++; // !RedXor (xortemp): skip over
  } // end for (it1)

  for (selectxor::iterator its = F.S.begin();
       its != F.S.end();) { // for all definitions in F.S
     seltemp = (*its).second; // assign temp with the current definition
     if (RedXor (seltemp)) {
       if (seltemp.empty()) { // if it's a valid unit clause
         XQ.Add((*its).first, FALSE);
         F.DelSel (its ++);
       }
       else
         if (seltemp.size() == 1) {
           var a;
           putty_xor (seltemp, a);
           XQ.Add ((*its).first, a);
           F.DelSel (its ++);
         }
       else { // temp.size() > 1
         var aux = (*its).first;
	 F.DelSel (its ++);
	 F.AddSel (aux, seltemp);
       }
      reductions ++;
    }
    else its ++; // !RedXor (seltemp): skip over
  } // end for (its)
  return reductions;
}
