/*****************************************************************************
+	TAME 1.0
+
+	select.C
 *****************************************************************************/

#include "../../include/rules.h"
#include "../../include/logger.h"

extern
tlogger logger;

static
inline
bool
depend (const xorclause & x, const assignmap & Ass) {
  xorclause::const_iterator itx;
  assignmap::const_iterator ita;
  for (itx = x.begin(); itx != x.end(); itx ++) {
    if ( (ita = Ass.find (abs(*itx)) ) != Ass.end() )
      return true;
  }
  return false;
}

static
inline
bool
depend (const xorclause & x, const selectxor & S) {
  xorclause::const_iterator itx;
  selectxor::const_iterator its;
  for (itx = x.begin(); itx != x.end(); itx ++) {
    if ( (its = S.find (abs (*itx)) ) != S.end() )
      return true;
  }
  return false;
}

static
inline
void
select (var & A, xorclause & x, formula & F) {
  var best_var;
  int best_score = 0;
  int temp_score;
  xorclause::iterator itx;
  for (itx = x.begin(); itx != x.end(); itx ++) {
    temp_score = F.getXorOccurrence (abs(*itx));
    /* probably it's good to make (for the var v):
      temp_score = F.getXorOccurrence(v) - F.getSelOccurrence(v);
      if (is_good_for_splitting (v))
        temp_score -= (best_score/2);
     */
   if (temp_score > best_score) {  
      best_score = temp_score;
      best_var = abs (*itx);
    }
  } // end for all prop in xclause
  A = best_var;
  return;
}

var
Select (formula & F) {
  var A;
  xorclauset::iterator itx;
  for (itx = F.X.begin(); itx != F.X.end();) {
    xorclause new_sel = (*itx);
    logger (8, "Current Selected Xorclause", new_sel);
    if (new_sel.size() < 3) {
      logger (8, "Size < 3");
      itx ++;
      continue;
    }  
    if (depend (new_sel, F.Ass) ) { // forse se po' toje (formula gia' sempl.)
      logger (8, "Depends on Assignment");
      itx ++;
      continue;
    }  
    if (depend (new_sel, F.S) ) {
      logger (8, "Depends on Selected");
      itx ++;
      continue;
    }  
    select (A, new_sel, F);
    F.AddSel (A, new_sel);
    F.DelXor (itx ++);
    return abs (A);
  } // endfor 
  return FALSE;
}

