/****************************************************************************
+	TAME 1.0
+
+	simp.C
 ****************************************************************************/

#include <iostream.h>
#include "../../include/rules.h"
#include "../../include/utils.h"
#include "../../include/logger.h"

extern
tlogger logger;

bool
Simp (formula & F, xorque & XQ) {
  while (!XQ.empty() ) {
    xorclause temp = XQ.Top(); // take the first element
    logger (6, "Processing the first assignment (in the xorque)");
    logger (9, "deleting the assignment from xorque:", XQ);
    XQ.Pop(); // delete the the first (computig) element
    if (temp.empty()) { // if have the bottom clause
      XQ.set_bottom();
      logger (6, "the xorque is empty!");
      return false;
    }
    if ( (temp.size () == 1) && 
         ( (*(temp.begin())) == TRUE))
      continue;	 
    // if you are here, the clause wasn't bottom so...
    var A, B; // comodity temporaneus vars
    putty_xor (temp, A, B); // put props in A, B
    logger (6, "Simplifiing the XQ");
    logger (9, "with the assignment", A, B);
    SimpQue (XQ, A, B); // simplify with A:= B the XQ
    logger (9, "XQ Simplified:", XQ);
    if (XQ.bottom()) {
      F.C.set_bottom();
      logger (6, "XQ.bottom()");
      return false;
    }  
    logger (9, "Adding the Assignment in F", F.Ass);
    F.AddAssign (A, B); // add the assign in F.Ass and extend it, so ...
    logger (9, "Assignment Added in F.Ass", F.Ass);
    logger (9, "Setting the change flag");
    F.set_changed(); // set the change flag
    logger (6, "Simplifing the XOR (Unselected and Selected) Sets");
    logger (9, "with the assign: ", A, B);
    SimpXor (F, A, B, XQ); // SimpXor -> RedXor -> UnitXor -> XQ.Add
    logger (9, "The simplified XOR Set", F.X);
    logger (9, "The simplified Select Xor Set", F.S);
    if (F.bottom() || XQ.bottom()) return false;
    logger (6, "Simplifing the OR set");
    logger (9, "with the assign: ", A, B);
    SimpOr (F, A, B, XQ); // SimpOr -> RedOr -> UnitOr -> XQ.Add
    logger (9, "The simplified OR Set", F.C);
    if (F.bottom() || XQ.bottom()) {
      logger (6, "Bottom");
      return false;
    }  
  }
  return true;
}  
