/*****************************************************************************
+	TAME 1.0
+
+	simpOr.C
 *****************************************************************************/

#include "../../include/rules.h"

static
bool
simp (orclause & c, const var A, const var B) {
  bool simp_made = false; // (almost 1) simplification made flag
  orclause::iterator itcl; // iterator on the current clause
  if ( (itcl = c.find (A)) != c.end()) { // if find (A)
    simp_made = true; // set the flag for success
    c.erase (itcl); // delete old literal...
    c.add (B); // ... and add the new 
  } //end if find (A)
  if ( (itcl  = c.find (not (A))) != c.end()) {
    simp_made = true; // set the flag for success
    c.erase (itcl); // delete old literal...
    c.add (not (B)); // ... and add the new
  } // end if find (not (A)) 
  return simp_made;
}

int
SimpOr (formula & F, const var A, const var B, xorque & XQ) {
  orclause temp;
  bool simplified;
  int simplifications = 0;
  for (orclauset::iterator it1 = F.C.begin();
      it1 != F.C.end();) { //for all clause in F.C
    temp = (*it1); //assign the temp clause with current clause
    simplified = false; //reset the simplifing flag
    simplified = simp (temp, A, B); // simplifies and set flag
    if (simplified) { //it was a profit simplification
      RedOr (temp); // reduce the clause
      if (!UnitOr (temp, XQ)) { // if wasn't a valid unit clause
        if (XQ.bottom() ) { // there is a contraddiction
	  F.C.set_bottom ();
	  return 0; // exit immediately
	}  
	else { // !Unit && !XQ.bottom()
	  F.DelOr (it1 ++); //eliminate the old...
          F.AddOr (temp); //... and add the new (simplified)
	}
      } // end if (!Unit)
      else // Unit (new xorclause in XQ)
        F.DelOr (it1 ++); // so eliminate the orclause
      simplifications ++;
    }
    else it1 ++; //it wasn't profit: skip over
  } // end for (it1)
  return simplifications;
}


