/*****************************************************************************
+	TAME 1.0
+
+	simpQue.C
 *****************************************************************************/

#include "../../include/rules.h"

static
bool
simp (xorclause & c, const var A, const var B) {
  bool simp_made = false; // (almost 1) simplification made flag
  xorclause::iterator itcl; // iterator on the current clause
  if ( (itcl = c.find (A)) != c.end()) { // if find (A)
    simp_made = true; // set the flag for success
    c.erase (itcl); // delete old literal...
    c.add (B); // ... and add the new
  } //end if find (A)
  if ( (itcl  = c.find (not (A))) != c.end()) {
    simp_made = true; // set the flag for success
    c.erase (itcl); // delete old literal...
    c.add (not (B)); // ... and add the new
  } // end if find (not (A))
  return simp_made;
}

int
SimpQue (xorque & XQ, const var A, const var B) { 
  xorclause temp;
  bool simplified;
  int simplifications = 0;
  for (unsigned int i = 0; i < XQ.size(); i ++) {
    temp = XQ[i]; //assign the temp clause with current clause
    simplified = false; //reset the simplifing flag
    simplified = simp (temp, A, B); // simplifies and set flag
    if (simplified) { //it was a profit simplification
      RedXor (temp);
      if (temp.empty()) {
        XQ.set_bottom();
	return 0;
      }	
      XQ[i] = temp;
      simplifications ++;
    } // end if was a profit simplification
  } // end for (i)
  return simplifications;
}

