/*****************************************************************************
+	TAME 1.0
+
+	simpXor.C
 *****************************************************************************/

#include "../../include/rules.h"

static 
inline
void
putty_xor (const xorclause & x, var & a) {
  xorclause::iterator itx = x.begin();
  a = (*itx);
}  

static
bool
simp (xorclause & c, const var A, const var B) {
  bool simp_made = false; // (almost 1) simplification made flag
  xorclause::iterator itcl; // iterator on the current clause
  if ( (itcl = c.find (A)) != c.end()) { // if find (A)
    simp_made = true; // set the flag for success
    c.erase (itcl); // delete old literal...
    c.add (B); // ... and add the new
  } //end if find (A)
  if ( (itcl  = c.find (not (A))) != c.end()) {
    simp_made = true; // set the flag for success
    c.erase (itcl); // delete old literal...
    c.add (not (B)); // ... and add the new
  } // end if find (not (A))
  return simp_made;
}

int
SimpXor (formula & F, const var A, const var B, xorque & XQ) { 
  xorclause temp;
  bool simplified;
  int simplifications = 0;
  for (xorclauset::iterator it1 = F.X.begin();
      it1 != F.X.end();) { //for all clause in F.X
    temp = (*it1); //assign the temp clause with current clause
    simplified = false; //reset the simplifing flag
    simplified = simp (temp, A, B); // simplifies and set flag
    if (simplified) { //it was a profit simplification
      RedXor (temp); // reduce the clause
      if (!UnitXor (temp, XQ)) { // if it wasn't a valid unit clause
        if (XQ.bottom() ) {
	  F.X.set_bottom();
	  return 0;
	} 
	else { // !Unit && !XQ.bottom()
	  F.DelXor (it1++); //eliminate the old...
          F.AddXor (temp); //... and add the new (simplified)
	}
      }	
      else // Unit (new xorclause in XQ)
        F.DelXor (it1 ++); // so eliminate the xorclause
      simplifications ++;
    }
    else it1 ++; //it wasn't profit skip over
  } // end for (it1)
  for (selectxor::iterator it2 = F.S.begin();
      it2 != F.S.end();) { //for all definition-clause in F.S
    temp = (*it2).second; //assign the temp clause with current clause
    simplified = false; //reset the simplifing flag
    simplified = simp (temp, A, B); // simplifies and set flag
    if (simplified) { //it was a profit simplification
      RedXor (temp); // reduce the clause
      if (temp.empty()) { // if it's a valid unit clause
        XQ.Add((*it2).first, FALSE); 
        F.DelSel (it2 ++);
        }
      else 
        if (temp.size() == 1) {
	  var a;
          putty_xor (temp, a);
	  XQ.Add ((*it2).first, a);
	  F.DelSel (it2 ++);
	}
      else { // temp.size() > 1
        var aux = (*it2).first;
	temp.add (not (aux));
	F.DelSel (it2 ++);
	F.AddSel (aux, temp);
      }
      simplifications ++;
    } // !simplified
    else it2 ++;
  } // end for (it2)
  return simplifications;
}

