/*****************************************************************************
+	TAME 1.0
+
+	split.C
 *****************************************************************************/

#include "../../include/rules.h"
#include "../../include/heuristics.h"

extern
bool SELECTIVE_SPLIT;

extern
char splitting_char;

extern
tpriority priority;

var
Split (const formula & F, lassign & VB) {
  if (F.C.empty())
    return FALSE;
  float best_score = 0; // the score of the best proposition
  float tmp_score = 0; // the score of the current proposition
  var curr; // the current analyzing var
  var best_var = FALSE; // the best proposition
  var tmp_var; // the current proposition
  vset::const_iterator itv;
  for (itv = F.V.begin(); itv != F.V.end(); itv ++) {
    curr = (*itv).first;
    if (SELECTIVE_SPLIT && (curr.name() != splitting_char))
      continue;
    if (VB.Find (curr))
      continue;
    if (F.Ass.find (curr) != F.Ass.end())
      continue;
    if (!F.occur (curr))  
      continue;
    tmp_score = priority (F, curr, tmp_var );
    if (tmp_score > best_score) {
      best_var = tmp_var; // set the best prop
      best_score = tmp_score; // set the best score
    }
  } // end for all variables in F.V 
  return best_var;
}

